set_verbose 1

#Create container dimensions

create_container_dimension shopper_product_interest_2066  rater_domain=user ratee_domain=item maximum_rating_value=10 minimum_rating_value=1 is_enabled=true

create_container_dimension shopper_product_likert_2066  rater_domain=user ratee_domain=item maximum_rating_value=10 minimum_rating_value=1 is_enabled=true


#Create rating strategies

create_rating_strategy shopper_interest_rating_strategy_2066 dimension=shopper_product_interest_2066

create_rating_strategy shopper_likert_rating_strategy_2066 dimension=shopper_product_likert_2066


#Create prediction strategies

create_interest_prediction_strategy  shopper_interest_recommendation_strategy_2066 prediction_algorithm=interest::adaptive ratings_container_dimension=shopper_product_interest_2066 select_object=Unrated sort_key=prediction sort_order=decreasing minimum_prediction_value=0.0 object_category_container_dimension=item_category minimum_potential_neighbors_to_examine=1  maximum_potential_neighbors_to_examine=50 subject_preference_container_dimension=shopper_product_interest_2066 subject_category_container_dimension=shopper_product_interest_2066 

create_likert_prediction_strategy  shopper_likert_recommendation_strategy_2066 prediction_algorithm=likert::adaptive ratings_container_dimension=shopper_product_likert_2066 select_object=Unrated sort_key=prediction sort_order=decreasing minimum_prediction_value=0.0 object_category_container_dimension=item_category minimum_potential_neighbors_to_examine=1  maximum_potential_neighbors_to_examine=50 subject_preference_container_dimension=shopper_product_likert_2066 subject_category_container_dimension=shopper_product_likert_2066 


#Cross Sell: Create container dimensions and prediction and rating strategies

create_container_dimension fast_lookup_object_2066  rater_domain=item ratee_domain=item_category maximum_rating_value=10 minimum_rating_value=1 is_enabled=true

create_container_dimension fast_lookup_subject_2066  rater_domain=item ratee_domain=item_category maximum_rating_value=10 minimum_rating_value=1 is_enabled=true

create_rating_strategy fast_lookup_object_rating_strategy_2066 dimension=fast_lookup_object_2066

create_rating_strategy fast_lookup_subject_rating_strategy_2066 dimension=fast_lookup_subject_2066

create_fast_lookup_prediction_strategy fast_lookup_recommendation_strategy_2066 fast_lookup_objects_container_dimension=fast_lookup_object_2066 fast_lookup_subjects_container_dimension=fast_lookup_subject_2066 prediction_algorithm=default



