 
/****************************************************************************************/
/*                                                                                      */
/* Licensed Materials - Property of IBM                                                 */
/*                                                                                      */
/* 5697-D24                                                                             */
/*                                                                                      */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved                      */
/*                                                                                      */
/* US Government Users Restricted Rights - Use, duplication or                          */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp.                    */
/*                                                                                      */
/****************************************************************************************/

// f 26383 tacktong 08/13/98 add new task PROFILE_UPD_PROD and its parameter names

#ifndef _tasks_api_h_
#define _tasks_api_h_


#define _PR_NAME_(Name)  extern const StringWithOwnership __DLL_NCS_API__ _PARAM_NAME_##Name
   // Reference numbers
   _PR_NAME_(ADDRESS_REF_NUM  );
   _PR_NAME_(ORDERITEM_REF_NUM);
   _PR_NAME_(ORDER_REF_NUM    );
   _PR_NAME_(PRODUCT_REF_NUM  );
   _PR_NAME_(SKU_REF_NUM      );
   // Other parameters
   _PR_NAME_(BASE_CURRENCY);
   _PR_NAME_(BASE_PRODUCT_PRICE);
   _PR_NAME_(CURRENCY         );
   _PR_NAME_(PRODUCT_PRICE    );
   _PR_NAME_(PRICE_EXPIRY_DATE);
   _PR_NAME_(PRODUCT_TAX      );
   _PR_NAME_(PRODUCT_SHIPPING );
   _PR_NAME_(PRODUCT_SHIPPING_TAX);
   _PR_NAME_(QUANTITY         );
   _PR_NAME_(TAX1             );
   _PR_NAME_(TAX2             );
   _PR_NAME_(TAX3             );
   _PR_NAME_(TAX4             );
   _PR_NAME_(TAX5             );
   _PR_NAME_(TAX6             );
   _PR_NAME_(TAX_TOTAL        );
   _PR_NAME_(TOTAL_AMOUNT     );
   _PR_NAME_(EXPECTED_CH_ANS  );
   _PR_NAME_(CH_ANS           );
   _PR_NAME_(MER_TEMPLATE    );
   _PR_NAME_(SH_TEMPLATE      );
   _PR_NAME_(ORDER_RN         );
   _PR_NAME_(ORDER_NOT_MSG    );

   // Parameters passed between APIs.
   _PR_NAME_(DISCOUNT_INFORMATION);
   _PR_NAME_(ERR_TEXT            );
   _PR_NAME_(ERR_NOTIF_MSG       );
   _PR_NAME_(ADDRESS             );
   _PR_NAME_(USER                );
   _PR_NAME_(NEW_PWD             );
   _PR_NAME_(PWD_RESET_MSG       );
   // f26383 starts
   _PR_NAME_(BEHAVIOR         );
   _PR_NAME_(PRODUCT_REF_NUM_LIST);
   _PR_NAME_(REC_ENGINE_OPTIONS);
   // f26383 ends
   _PR_NAME_(ORDER_STATE);
   _PR_NAME_(JOB_RN	          );
 
   	

#undef _PR_NAME


#define _TK_NAME_(Name) extern const StringWithOwnership  __DLL_NCS_API__ _TASK_##Name

   // View tasks
   _TK_NAME_(ORD_LST_PEN );
   _TK_NAME_(ORD_LST_COM );
   _TK_NAME_(ORD_DSP_PEN );
   _TK_NAME_(ORD_DSP_COM );
   _TK_NAME_(ORD_OK      );
   _TK_NAME_(SHOPCART_DSP);
   _TK_NAME_(SHIPTO_LST  );
   _TK_NAME_(SHIPTO_DSP  );
   _TK_NAME_(SHIPTO_ASSOC);
   _TK_NAME_(REG_NEW     );
   _TK_NAME_(REG_UPDATE  );
   _TK_NAME_(CAT_DSP     );
   _TK_NAME_(PROD_DSP    );
   _TK_NAME_(PWD_RESET   );
   _TK_NAME_(PWD_UPDATE  );
   _TK_NAME_(PWD_ADMIN   ); 
   _TK_NAME_(USER_AUTH   );


   // Error tasks
   _TK_NAME_(BAD_PROD_ATTR    );
   _TK_NAME_(BAD_REG          );
   _TK_NAME_(ORD_UNLOCKED     );
   _TK_NAME_(ORD_NONE         );
   _TK_NAME_(BAD_ST_DATA      );
   _TK_NAME_(BAD_ORD_DATA     );
   _TK_NAME_(MISSING_PROD_ATTR);
   _TK_NAME_(BAD_ADDRESS_BOOK );
   _TK_NAME_(BAD_REG_MODIFY   );
   _TK_NAME_(BAD_ADRBK_MODIFY );
   _TK_NAME_(BAD_PWD_UPDATE   );
   _TK_NAME_(BAD_PWD_RESET    );
   _TK_NAME_(BAD_LOGID        );
   _TK_NAME_(BAD_PWD_ADMIN    );
   _TK_NAME_(BAD_USER_AUTH    );
   _TK_NAME_(ADRBK_DEL        );
   _TK_NAME_(LOGIN            );

   // API tasks
   _TK_NAME_(AUDIT_REG               );
   _TK_NAME_(AUDIT_ADDR_BOOK         );
   _TK_NAME_(CHECK_INV);
   _TK_NAME_(EXT_SHIPTO_UPD          );
   _TK_NAME_(EXT_SHIPTO_PROC         );
   _TK_NAME_(UPDATE_INV              );
   _TK_NAME_(GET_BASE_UNIT_PRC);
   _TK_NAME_(GET_BASE_SPE_PRC);
   _TK_NAME_(GET_SUB_ORD_PROD_TOT    );
   _TK_NAME_(GET_ORD_PROD_TOT        );
   _TK_NAME_(GET_SUB_ORD_PROD_TAX_TOT);
   _TK_NAME_(GET_ORD_PROD_TAX_TOT    );
   _TK_NAME_(GET_SUB_ORD_SH_TOT      );
   _TK_NAME_(GET_ORD_SH_TOT          );
   _TK_NAME_(DO_PAYMENT              );
   _TK_NAME_(EXT_ORD_PROC            );
   _TK_NAME_(DEMO_API                );
   _TK_NAME_(RESOLVE_SKU);
   _TK_NAME_(REV_UPDATE_INV          );
   _TK_NAME_(CHECK_CHANS             );
   _TK_NAME_(EXT_REFRESH             );
   _TK_NAME_(EXT_REFRESHALL          );
   _TK_NAME_(SET_CURRENCY_PREFERENCE );
   _TK_NAME_(GET_CURRENCY            );
   // f26383 starts
   _TK_NAME_(PROFILE_UPD_PROD        );
   // f26383 ends

   // Notification tasks
   _TK_NAME_(GET_ERR_NOTIF_MSG         );
   _TK_NAME_(CREATE_PWD_RESET_NOTIF_MSG);
   _TK_NAME_(PWD_RESET_NOTIFICATION    );
   _TK_NAME_(ORD_NOTIFY				   );
   _TK_NAME_(ORDER_NOTIFY            );		
#undef _TK_NAME_

#endif
