/****************************************************************************************/
/*                                                                                      */
/* IBM Confidential                                                                     */
/*                                                                                      */
/* Net.Commerce Source Materials                                                        */
/*                                                                                      */
/* (C) Copyright IBM Corp. 1996, 1997.                                                  */
/*                                                                                      */
/* The source code for this program is not published or otherwise divested of its trade */
/* secrets, irrespective of what has been deposited with the U.S. Copyright Office.     */
/*                                                                                      */
/****************************************************************************************/

#ifndef _INTERESTITEM_CMDS_H_
#define _INTERESTITEM_CMDS_H_


//////////////////////////////////////////////////////////////////////////////////////////
//
//  Command InterestItemAdd
//

class __DLL_NCS_CMD__ CommandInterestItemAdd : public NC_Command
{

public:
   CommandInterestItemAdd() : _product_rn() { }
   ~CommandInterestItemAdd() { }

   void operator delete( void* p ) { ::delete p; }

public:
   virtual bool CheckParameters( const HttpRequest& Req, 
                                 HttpResponse& Res,
                                 NC_Environment& Env, 
                                 NC_Environment& Resources );
   virtual bool Process( const HttpRequest& Req,
                         HttpResponse& Res, 
                         NC_Environment& Env );

private:
   // Url Name Value Pairs:
   String _product_rn;
   String _Field1;
   String _Field2;
   String _Field3;
};


//////////////////////////////////////////////////////////////////////////////////////////
//
//  Command InterestItemDelete
//

class __DLL_NCS_CMD__ CommandInterestItemDelete : public NC_Command
{

public:
   CommandInterestItemDelete() : _product_rn() { }
   ~CommandInterestItemDelete() { }

   void operator delete( void* p ) { ::delete p; }

public:
   virtual bool CheckParameters( const HttpRequest& Req, 
                                 HttpResponse& Res,
                                 NC_Environment& Env, 
                                 NC_Environment& Resources );
   virtual bool Process( const HttpRequest& Req,
                         HttpResponse& Res, 
                         NC_Environment& Env );

private:
   // Url Name Value Pairs:
   String _product_rn;
};


//////////////////////////////////////////////////////////////////////////////////////////
//
//  Command InterestItemDisplay
//

class __DLL_NCS_CMD__ CommandInterestItemDisplay : public NC_Command
{

public:
   CommandInterestItemDisplay()  : _merchant_rn() { }
   ~CommandInterestItemDisplay() { }

   void operator delete( void* p ) { ::delete p; }

public:
   static bool UpdateInterestItemPrices( const HttpRequest& Req,
                                         HttpResponse& Res, 
                                         NC_Environment& Env,
                                         const User& user,
                                         const String& merchant_rn,
                                         bool onlyIfCurrencyChange );
   virtual bool CheckParameters( const HttpRequest& Req, 
                                 HttpResponse& Res,
                                 NC_Environment& Env, 
                                 NC_Environment& Resources );
   virtual bool Process( const HttpRequest& Req,
                         HttpResponse& Res, 
                         NC_Environment& Env );

private:
   // Url Name Value Pairs:
   String _merchant_rn;
};


#endif

