/****************************************************************************************/
/*                                                                                      */
/* IBM Confidential                                                                     */
/*                                                                                      */
/* Net.Commerce Source Materials                                                        */
/*                                                                                      */
/* (C) Copyright IBM Corp. 1996, 1997.                                                  */
/*                                                                                      */
/* The source code for this program is not published or otherwise divested of its trade */
/* secrets, irrespective of what has been deposited with the U.S. Copyright Office.     */
/*                                                                                      */
/****************************************************************************************/

#ifndef _LOGON_H_
#define _LOGON_H_


//////////////////////////////////////////////////////////////////////////////////////////
//
// User Command : CommandLogon.
//
//////////////////////////////////////////////////////////////////////////////////////////

class __DLL_NCS_CMD__ CommandLogon : public NC_Command
 {
   static ClassName _STR_ThisClass;
   const static StringWithOwnership _IS_REGISTERED_FLAG;

   public:
    CommandLogon() { }
    void  operator delete( void* p ) { ::delete p; }

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);

    static bool VerifyPassword       (User* user, String Pwd, const String& MerchantKey);
    static bool CreateSessionIDCookie(const String& SESSION_ID, String& Cookie, const String& MerchantKey);

   protected:
    String _Name;
    String _Password;
    String _ConfirmPwd;
    String _Url;
    String _MerchantRefNum;
 };


#endif


