/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (C) Copyright IBM Corp. 1998. All Rights Reserved                 */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA, ADP Schedule Contract with IBM Corp.*/
/*                                                                   */
/*********************************************************************/
//July 20/98   S. Bliakhman  -- File creation
//////////////////////////////////////////////////////////////////////////////////////////
// Change History
//////////////////////////////////////////////////////////////////////////////////////////
// YYMMDD  F/D#   WHO    Description
// ---------------------------------------------------------------------------------------
// 
//
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef _PDIDISPLAY_H_
#define _PDIDISPLAY_H_


//////////////////////////////////////////////////////////////////////////////////////////
//
// User Command : GetPaymentInfo.
//
//////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ CommandGetPaymentInfo : public NC_Command
{
    
    static ClassName _STR_ThisClass;


   public:
    
       CommandGetPaymentInfo(       ) : _OrderRefNum(_STR_EMPTY_) {}    
       void  operator delete    (void* p) { ::delete p; }


   public:    
       virtual bool CheckParameters(const HttpRequest&    Req, 
                                          HttpResponse&   Res,
                                          NC_Environment& Env, 
                                          NC_Environment& Resources);    
       virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);

   protected:

       String           _OrderRefNum   ; 
       String           _Url           ;

   private:
       // returns a list payment methods for given order
       OrdPayMthdList * FindOrderPaymentInfo           (OrdPayMthdHome & pay_method_home, const String & OrderRefNum              );
       // parses year and month from db timestamp
       bool             ParseYearAndMonthFromTimestamp (const String   & TimeStamp,             String & Month,      String & Year);

};

#endif
