/****************************************************************************************/
/*                                                                                      */
/* IBM Confidential                                                                     */
/*                                                                                      */
/* Net.Commerce Source Materials                                                        */
/*                                                                                      */
/* (C) Copyright IBM Corp. 1998.                                                        */
/*                                                                                      */
/* The source code for this program is not published or otherwise divested of its trade */
/* secrets, irrespective of what has been deposited with the U.S. Copyright Office.     */
/*                                                                                      */
/****************************************************************************************/

#ifndef _RECOMMEND_PRODUCT_H_
#define _RECOMMEND_PRODUCT_H_


//////////////////////////////////////////////////////////////////////////////////////////
//
//  Command RecommendProduct
//

class RecommendProduct : public NC_Command
{

public:
   RecommendProduct() : _merchant_rn(), _from_rank(), _to_rank(),
                        _product_refnum_list(true) { }
   ~RecommendProduct() { }

   void operator delete( void* p ) { ::delete p; }

public:
   virtual bool CheckParameters( const HttpRequest& Req, 
                                 HttpResponse& Res,
                                 NC_Environment& Env, 
                                 NC_Environment& Resources );
   virtual bool Process( const HttpRequest& Req,
                         HttpResponse& Res, 
                         NC_Environment& Env );

private:
   String _merchant_rn;
   String _from_rank;
   String _to_rank;
   String _result_code;
   
   TemplateNC_PList<String, String> _product_refnum_list;
};

#endif

