#ifndef _register_h_
#define _register_h_

/*********************************************************************/
/*                                                                   */
/* IBM Confidential                                                  */
/*                                                                   */
/* Net.Commerce Source Materials                                     */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996.                                     */
/*                                                                   */
/* The source code for this program is not published or otherwise    */
/* divested of its trade secrets, irrespective of what has been      */
/* deposited with the U.S. Copyright Office.                         */
/*                                                                   */
/*********************************************************************/



/////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ RegisterBase : public NC_Command
 {
   static const ClassName _STR_ThisClass;

   public:
    RegisterBase(void) { }
    void  operator delete( void* p ) { ::delete p; }

   protected:
    String   _LogId     ;  
    String   _Password  ;
    String   _Url       ;
    NVPHash  _AddressNVP;
    NVPHash  _DemogNVP  ;

   protected:
    bool DoCheckParameters(const HttpRequest& Req, HttpResponse& Res,
                           NC_Environment& Env, NC_Environment& Resources,
                           const String& ErrorTaskName
                          );
    bool DoProcess        (const HttpRequest& Req, HttpResponse& Res,
                           NC_Environment& Env,
                           const String& ErrorTaskName
                          );
 };



/////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ RegisterNew : public RegisterBase
 {
   static const ClassName _STR_ThisClass;

   public:
    RegisterNew(void) { }
    void  operator delete( void* p ) { ::delete p; }

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };



/////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ RegisterUpdate : public RegisterBase
 {
   static const ClassName _STR_ThisClass;

   public:
    RegisterUpdate(void) { }
    void  operator delete( void* p ) { ::delete p; }

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };



/////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ RegisterForm : public NC_Command
 {
   static const ClassName _STR_ThisClass;

   public:
    RegisterForm(void)  { }
    ~RegisterForm() {  }
    void  operator delete( void* p ) { ::delete p; }

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ AdminRegisterNew : public NC_Command
 {
   static const ClassName _STR_ThisClass;

   public:
    AdminRegisterNew(void)  { }
    ~AdminRegisterNew() {  }
    void  operator delete( void* p ) { ::delete p; }

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };



/////////////////////////////////////////////////////////////////////////////////////////////////////
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ AdminRegisterUpdate : public NC_Command
 {
   static const ClassName _STR_ThisClass;

   public:
    AdminRegisterUpdate(void)  { }
    ~AdminRegisterUpdate() {  }
    void  operator delete( void* p ) { ::delete p; }

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };


#endif


