#ifndef _SET_CURRENCY_H_
#define _SET_CURRENCY_H_
/*********************************************************************/
/*                                                                   */
/* IBM Confidential                                                  */
/*                                                                   */
/* Net.Commerce Source Materials                                     */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996.                                     */
/*                                                                   */
/* The source code for this program is not published or otherwise    */
/* divested of its trade secrets, irrespective of what has been      */
/* deposited with the U.S. Copyright Office.                         */
/*                                                                   */
/*********************************************************************/

// To use this class template:
//  - Copy this file and its .cpp correspondant to files with your command name
//  - On both files, do a search on 'CommandSetCurrency' and replace with 'xxx' where xx is your command class name.
//  - Follow comments on each function to customize.

//////////////////////////////////////////////////////////////////////////////////////////
//
// Utility Class for use by other commands as well: PendingOrderCurrencyAdjusterUtility
//
//////////////////////////////////////////////////////////////////////////////////////////
class CurrencyAdjusterUtility : public NC_Void
{
 public:

  static bool AdjustInterestItemsForUser( const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env, 
                                          const User& user );
  static bool AdjustPendingOrdersForUser( const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env, 
                                          const User& user );
};

/////////////////////////////////////////////////////////////////////////////////////////////////////
// File:          order_process.cpp
// User Command : CommandSetCurrency.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ CommandSetCurrency : public NC_Command
{
 static ClassName _STR_ThisClass;

 String         _Currency;

 public:
  CommandSetCurrency()
  : _Currency()
  { }

  ~CommandSetCurrency();
  void  operator delete( void* p ) { ::delete p; }

 public:
  virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                               NC_Environment& Env, NC_Environment& Resources);
  virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
};

#endif
