#ifndef _gl_rating_schema_h_
#define _gl_rating_schema_h_
/*********************************************************************/
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved   */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/
///////////////////////////////////////////////////////////////////////
// This file is part of Net.Commerce                                 //
// Header file for GL_Rating.                                               //
///////////////////////////////////////////////////////////////////////




class StaticSQL;

class __DLL_NCS_OBJ__ GL_Rating : public SQL_Schema
 { 
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL; 
   friend class GL_RatingHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
     // Database against which the object is used. If LoadAll is true, the object loads 
     //all fields at once. Otherwise, loads the minimum set, and will load the others 
     //on demand
    GL_Rating(DataBase& DB, bool LoadAll=true);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME           ;
    static const StringWithOwnership _COL_BEHAVIOR_REF_NUM;
    static const StringWithOwnership _COL_MERCHANT_REF_NUM;
    static const StringWithOwnership _COL_RATING          ;
    static const StringWithOwnership _COL_RATING_LEVEL    ;
    static const StringWithOwnership _COL_ENABLE          ;

   public: // Get functions
    const String& getBehaviorRefNum(bool Real=true);
    const String& getMerchantRefNum(bool Real=true);
    const String& getRating        (bool Real=true);
    const String& getRatingLevel   (bool Real=true);
    const String& getEnable        (bool Real=true);

   public: // Set functions
    void setBehaviorRefNum(const String& BehaviorRefNum);
    void setMerchantRefNum(const String& MerchantRefNum);
    void setRating        (const String& Rating        );
    void setRatingLevel   (const String& RatingLevel   );
    void setEnable        (const String& Enable        );
 };



class __DLL_NCS_OBJ__ GL_RatingHome : public SQL_SchemaMap<GL_Rating>
 { 
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging 
   static const FuncName  _STR_Create; 
   static const FuncName  _STR_Lookup; 

   public: 
    GL_RatingHome(DataBase& DB)  : SQL_SchemaMap<GL_Rating>(DB) { }


   public: 
    GL_Rating* Create(const String& BehaviorRefNum, const String& Rating, const String& Enable, const NVPHash& NameValuePairs);
    GL_Rating* Lookup(const NVPHash& NameValuePairs);
    GL_Rating* LookupByRefNum(const String& BehaviorRefNum, const String& MerchantRefNum, const NVPHash& NameValuePairs);
 };






#endif

