

/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996, 1998. All Rights Reserved           */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA, ADP Schedule Contract with IBM Corp.*/
/*                                                                   */
/*********************************************************************/
#ifndef _MACRO_H_
#define _MACRO_H_

class __DLL_NCS_OBJ__ NetDataMacro
 {
   public:
    // Sets up a Net.Data macro. In the constructor, we create our own NameValuePairMap.
    // We copy the NVPs from the Request, then the ones in Macro_NVPHash from Env, if it
    // is there, then the ones from NVP. We do 'setUnique', so each NVP will overwrite
    // any previously set one. Then, if they are present, we add the "error_code" and
    // "field" variables from Env. Then, we add the "SESSION_ID" (the user's LogingID),
    // the "SESSION_RN" (the user's reference number) and "HOST_NAME" name value pairs
    // (the value of the MS_HOST_NAME variable in the configuration file). Finally, we
    // propagate all cookies to the macro as NVPs: the cookie "xyz" will become the NVP
    // "NC_COOKIE_xyz" readily accessible by the macro.
    NetDataMacro(DataBase& DB, const HttpRequest& Req, const NC_Environment& Env,
                 const NVPHash& NVP);

   private:
          DataBase&         _DB      ;
    const HttpRequest     & _Req     ;
    const NC_Environment  & _Env     ;
          NameValuePairMap  _NVPMap  ;
          String            _Name    ;
          String            _Document;

   protected:

   public:
    void setName (const String& name) { _Name  = name; }

    const String& getName    () const { return _Name    ; }
    const String& getDocument() const { return _Document; }

    bool ResolveName(const String& TaskName, const String& MerchantRefNum);
    bool Exec       (const String& block);
 };

#endif


