#ifndef _merprofile_schema_h_
#define _merprofile_schema_h_
/*********************************************************************/
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved   */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/
///////////////////////////////////////////////////////////////////////
// This file is part of Net.Commerce                                 //
// Header file for MerProfile.                                               //
///////////////////////////////////////////////////////////////////////




class StaticSQL;

class __DLL_NCS_OBJ__ MerProfile : public SQL_Schema
 { 
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL; 
   friend class MerProfileHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
     // Database against which the object is used. If LoadAll is true, the object loads 
     //all fields at once. Otherwise, loads the minimum set, and will load the others 
     //on demand
    MerProfile(DataBase& DB, bool LoadAll=true);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME       ;
    static const StringWithOwnership _COL_REF_NUM     ;
    static const StringWithOwnership _COL_MER_MPCUR   ;
    static const StringWithOwnership _COL_MER_VERSION ;
    static const StringWithOwnership _COL_MER_ENABLE  ;
    static const StringWithOwnership _COL_MER_CSTMP   ;
    static const StringWithOwnership _COL_MER_ANIVSTMP;

   public: // Get functions
    const String& getRefNum       (bool Real=true);
    const String& getmercurrency  (bool Real=true);
    const String& getmerversion   (bool Real=true);
    const String& getmerenable    (bool Real=true);
    const String& getmertimestamp (bool Real=true);
    const String& getmeratimestamp(bool Real=true);

   public: // Set functions
    void setRefNum       (const String& RefNum       ) { SQL_Schema::setValue(_COL_REF_NUM     ,RefNum       ); }
    void setmercurrency  (const String& mercurrency  ) { SQL_Schema::setValue(_COL_MER_MPCUR   ,mercurrency  ); }
    void setmerversion   (const String& merversion   ) { SQL_Schema::setValue(_COL_MER_VERSION ,merversion   ); }
    void setmerenable    (const String& merenable    ) { SQL_Schema::setValue(_COL_MER_ENABLE  ,merenable    ); }
    void setmertimestamp (const String& mertimestamp ) { SQL_Schema::setValue(_COL_MER_CSTMP   ,mertimestamp ); }
    void setmeratimestamp(const String& meratimestamp) { SQL_Schema::setValue(_COL_MER_ANIVSTMP,meratimestamp); }
 };



class __DLL_NCS_OBJ__ MerProfileHome : public SQL_SchemaMap<MerProfile>
 { 
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging 
   static const FuncName  _STR_Create; 
   static const FuncName  _STR_Lookup; 

   public: 
    MerProfileHome(DataBase& DB)  : SQL_SchemaMap<MerProfile>(DB) { }


   public: 
    MerProfile* Create(const NVPHash& NameValuePairs);
    MerProfile* Lookup(const NVPHash& NameValuePairs);
    bool ExtendCurrent(String MerRefNum);
 };



class __DLL_NCS_OBJ__ MerProfileNVP : public NC_Void
 { 
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
       static const StringWithOwnership _NVP_REF_NUM  ;

   public: 
    static bool CreateSchemaNVP(const HttpRequest& Req, NC_Environment& Env,
                                const String& ErrorTask, const String& MerchantRefNum,
                                NVPHash& NameValuePairs
                               );
    static void SetThroughNVP  (const HttpRequest& Req, MerProfile* R);

 };



#endif

