#ifndef _PAYMENT_H_
#define _PAYMENT_H_

/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved   */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/

//LDH// We never got the time to implement static SQL logic, so this code is not needed
//LDH// class StaticSQL;

//LDH// We should include these objects in our code tree. But in the meantime, you should
// not use the same DLL flag __DLL_NCS_OBJ__... Use __DLL_CSP__OBJ instead for instance.

class __DLL_NCS_OBJ__ Payment : public SQL_Schema
{
//LDH// We never got the time to implement static SQL logic, so this code is not needed
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
//LDH//   friend class StaticSQL;
//LDH//   friend class PaymentHome;

public:
  Payment(DataBase& DB);

//LDH// Some compilers may barf at this code... The Payment qulifier is redundant.
  static const StringWithOwnership /*LDH Payment::*/_COL_TNAME;
  static const StringWithOwnership /*LDH Payment::*/_COL_REF_NUM;
  static const StringWithOwnership /*LDH Payment::*/_COL_PAYMENT_METHOD;
  static const StringWithOwnership /*LDH Payment::*/_COL_PAYMENT_ID;
  static const StringWithOwnership /*LDH Payment::*/_COL_EXP_DATE;
  static const StringWithOwnership /*LDH Payment::*/_COL_ISSUE_DATE;
  static const StringWithOwnership /*LDH Payment::*/_COL_MAX_AMOUNT;



//LDH// You should allow the users of the object to ask for the real value (default) of the wished
//     value... Modify the code as follows.
//LDH// Bad: const String& getRefNum(void) const         { return SQL_Schema::getValue(_COL_REF_NUM     );}
//LDH// Good:
             const String& getRefNum(bool Real=true) const { return SQL_Schema::getValue(_COL_REF_NUM, Real);}
//LDH// Bad:  const String& getPaymentMethod(void) const    { return SQL_Schema::getValue(_COL_PAYMENT_METHOD);}
//LDH// Bad:  const String& getPaymentID(void) const        { return SQL_Schema::getValue(_COL_PAYMENT_ID);}
//LDH// Bad:  const String& getExpirationDate(void) const   { return SQL_Schema::getValue(_COL_EXP_DATE);}
//LDH// Bad:  const String& getIssueDate(void) const        { return SQL_Schema::getValue(_COL_ISSUE_DATE);}
//LDH// Bad:  const String& getMaxAuthAmount(void) const    { return SQL_Schema::getValue(_COL_MAX_AMOUNT);}

  void setRefNum(const String& RefNum)                 { SQL_Schema::setValue(_COL_REF_NUM, RefNum); }
  void setPaymentMethod(const String& PaymentMethod)   { SQL_Schema::setValue(_COL_PAYMENT_METHOD, PaymentMethod);}
  void setPaymentID(const String& PaymentID)           { SQL_Schema::setValue(_COL_PAYMENT_ID, PaymentID);}
  void setExpirationDate(const String& ExpirationDate) { SQL_Schema::setValue(_COL_EXP_DATE , ExpirationDate);}
  void setIssueDate(const String& IssueDate)           { SQL_Schema::setValue(_COL_ISSUE_DATE, IssueDate);}
  void setMaxAuthAmount(const String& MaxAuthAmount)   { SQL_Schema::setValue(_COL_MAX_AMOUNT, MaxAuthAmount);}
};

typedef TemplateNC_PList<Payment, String> PaymentList;

class __DLL_NCS_OBJ__ PaymentHome : public SQL_SchemaMap<Payment>
{
  #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif

private:

public:
  PaymentHome(DataBase& DB) : SQL_SchemaMap<Payment>(DB) { }

public:
  Payment* Create(const String& OrderRefNum, const NVPHash& NameValuePairs);
  Payment* Lookup(const String& RefNum, const NVPHash& NameValuePairs);
};

#endif
