@echo off

rem
rem persdemo_migrate.cmd
rem

set old_dbname=%dbname%
set old_install_demomall=%install_demomall%
set old_logfile=%logfile%

set dbname=
set install_demomall=
set logfile=persdemo_migrate.log

if "%1" == "" goto __USAGE__
set dbname="%1"
goto __MIGRATE__


:__MIGRATE__

echo.
echo Migrating database %1 to enable personalization
echo.
echo If you do not see the message "Migration complete",
echo then please check the logfile %logfile% for error
echo messages.
echo.

if exist %logfile%  erase %logfile%

db2 "connect to %dbname%" >> %logfile%

if errorlevel 1 goto __ERROR__

echo.
echo Adding dummy shoppers...
db2 -tsvf demomall\persdemo_shoppers.db2.sql >> %logfile%

echo;
echo Adding mappings between explicit profiling behaviours and GroupLens ratings;
echo;

db2 delete from task_mer_of where (TASK_RN=(select tkrfnbr from tasks  where tkname='PROFILE_UPD_PROD' and MERCHANT_RN=%2 ))

db2 delete from task_mer_of where (TASK_RN=(select tkrfnbr from tasks where tkname='PROFILE_UPD_PROD'))


db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='X_REMOVE_RATING'), %2, 1, 0, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='X_VERY_PLEASED'),%2, 5, 22, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='X_PLEASED'), %2,4, 22, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='X_SATISFIED'),%2, 3, 22, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='X_NEUTRAL'),%2, 2, 22, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='X_DISAPPOINTED'), %2,1, 22, 1)

echo;
echo Adding mappings between explicit profiling behaviours and GroupLens ratings;
echo;

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='ClickOnProduct'), %2, 2, 16, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='AddInterestProduct'), %2, 3, 18, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='RemoveInterestProduct'), %2 , 3, 18, 1)

db2 insert into gl_behrate (beh_rn, mer_rn, rating, r_level, enable) values ((select refnum from behavior where name='OrderProduct'),  %2, 4, 20, 1)



db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='SELECT_UNRATED_PRODUCTS'), %2,(select refnum from ofs where name='GL_ProfileSelectUnratedProd'))

db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='GET_RATING_HISTORY'),%2, (select refnum from ofs where name='GL_GetRatingHistory' and  version=1.0 and vendor='IBM' and product='NC'))


db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='GL_GET_REC_PROD'), %2, (select refnum from ofs where name='GL_GetRecProd'))

db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='PROFILE_UPD_ATTR'),%2 , (select refnum from ofs where name='GL_ProfileUpdAttr' ))

db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='GL_GET_REC_PROD_FR_LIST'), %2, (select refnum from ofs where   name='GL_GetRecProdFrList' ))

db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='REC_PROD_DSP'), %2, (select refnum from ofs where name='TaskDisplay' ))

db2 insert into macros (MARFNBR, MAMERNBR, MAFILENAME) values ((select tkrfnbr from tasks where tkname='REC_PROD_DSP'), %2, '/demomall/rcmnd1.d2w')

db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='GL_REMOVE_PROD_RATINGS'), %2, (select refnum from ofs where name='GL_RemoveProdRatings'))

db2 insert into task_mer_of (TASK_RN, MERCHANT_RN, OF_RN) values ((select tkrfnbr from tasks where tkname='PROFILE_UPD_PROD'), %2, (select refnum from ofs where name='GL_ProfileUpdProd'))



echo;
echo Link OFs for 6ixth Avenue. . .;
echo;



commit;





db2 "connect reset" >> %logfile%
goto __END_MIGRATE__


:__END_MIGRATE__
echo.   >> %logfile%
echo Migration complete.  >> %logfile%
echo.   >> %logfile%
echo.
echo Migration complete.
echo.
goto __quit


:__USAGE__
echo.
echo Migrate a database to enable personalization. 
echo.
echo Usage: 
echo.
echo pers_migrate dbname
echo.
echo     dbname = Name of the database to which to add
echo              personalization samples. 
echo.
goto __quit


:__ERROR__
echo.
echo An error has occurred. Please check the logfile
echo %logfile% for details.
echo.

goto __quit

:__quit
set dbname=%old_dbname%
set install_demomall=%old_install_demomall%
set logfile=%old_logfile%

rem end.


