@echo off

rem
rem pers_migrate.cmd
rem

set old_dbname=%dbname%
set old_install_demomall=%install_demomall%
set old_logfile=%logfile%
set old_dbuser=%dbuser%
set old_dbpswd=%dbpswd%

set dbname=
set install_demomall=
set logfile=pers_migrate.log
set dbuser=
set dbpswd=

if exist %logfile%  erase %logfile%

if "%1" == "" goto __USAGE__
if "%2" == "" goto __USAGE__
if "%3" == "" goto __USAGE__
if "%4" == "" goto __USAGE__
set dbname=%1
if not "%5" == "" set logfile=%5
if not "%2" == "" set dbuser=%2
if not "%3" == "" set dbpswd=%3
if not "%4" == "" set merchant_num=%4
echo dbname %dbname% logfile %logfile% dbuser %dbuser% dbpswd %dbpswd% merchant_num %merchant_num%
goto __MIGRATE__


:__MIGRATE__
set errorlevel=0
echo.
echo Migrating database %1 to enable personalization
echo.
echo If you do not see the message "Migration complete",
echo then please check the logfile %logfile% for error
echo messages.
echo.

if "%5" == ""  erase pers_migrate.log
db2 "connect to %dbname%" user %dbuser% using %dbpswd% >> %logfile%
if errorlevel 1 goto __ERROR__

echo.
echo Adding customer profiling information...
db2 -tvf pers_explicit_profiling.db2.sql >> %logfile%
db2 -tvf pers_implicit_profiling.db2.sql >> %logfile%
echo Registering personalization commands, tasks and overridable functions...
db2 -tvf pers_register_tasks_etc.db2.sql >> %logfile%

echo.
echo Adding personalization demo commands
call .\demomall\persdemo_migrate.cmd %1 %4

:__END_MIGRATE__
echo.   >> %logfile%
echo Migration complete.  >> %logfile%
echo.   >> %logfile%
echo.
echo Migration complete.
echo.
goto __quit


:__USAGE__
echo.
echo Migrate a database to enable personalization. 
echo.
echo Usage: 
echo.
echo echo pers_migrate dbname dbuser dbpass merchant_num [logfile]
echo.
echo     dbname = Name of the database to migrate
echo     dbuser/dbpass = Login and password for the
echo                     specified database
echo     merchant_num  = merchant reference number
echo     logfile = Migration log file. OPTIONAL.
echo               DEFAULT is 'pers_migrate.log'
echo
goto __quit
 

:__ERROR__
echo.
echo An error has occurred. Please check the logfile
echo %logfile% for details.
echo.
goto __quit

:__quit
set dbname=%old_dbname%
set install_demomall=%old_install_demomall%
set logfile=%old_logfile%
set dbuser=%old_dbuser%
set dbpswd=%old_dbpswd%

