#! /bin/ksh
#
# IBM
#
# Net.Commerce
#
# (C) Copyright IBM Corp. 1997, 1998.
#
# Net.Commerce Version 3.1.2 Database Creation Utility
#
#  Dependencies
#  This utility should be running from the command line
#

if [ -z "${NCPATH}" ]; then
  export NCPATH="/opt/IBMnetc/NetCommerce3"
fi

if [ $# -lt 4]; then
echo " "
echo "Migrate a database to enable personalization. "
echo
echo "Usage: "
echo " "
echo "pers_migrate_merchant dbname merchant_num dbuser dbpass [logfile] "
echo " "
echo "    dbname = Name of the database to migrate "
echo "    merchant_num = merchant reference number "
echo "    dbuser/dbpass = Login and password for the "
echo "                    specified database "
echo "    logfile = Migration log file. OPTIONAL. "
echo "              DEFAULT is pers_migrate.log "
echo ". "
exit 2
fi


if [ "$5" == "" ]; then 
  export logfile="pers_migrate.log"
  rm pers_migrate.log
fi

echo "Migrating database $1 to enable personalization "
echo 
echo "If you do not see the message Migration complete"
echo "then please check the logfile $logfile for error "
echo "messages. "
echo ". "


echo connecting to $1 
db2 connect to $1 2>&1 >> $logfile
if [ $? -ne 0 ]; then
  echo "Failed to connect to database!"
  return -1
fi


echo "Adding personalization demo commands "
./demomall/persdemo_migrate.sh $1 $2

echo "Migration complete."  >> $logfile 
echo   >> $logfile 
echo " Migration complete. "
echo " END ----- Check the log files --------------- "

