echo;
echo Registering new commands, tasks and overrideable functions
echo;

echo;
echo remove commands,tasks and ofs from the system;
echo;
delete from cmds where (NAME='RateProduct');
delete from cmds where (NAME='RecommendProduct');
delete from cmds where (NAME='RemoveProdRatings');
delete from cmds where (NAME='EnterMerchant');
delete from cmds where (NAME='CrossSellMerchant');
delete from cmds where (NAME='PersonalizationCenter');
delete from cmds where (NAME='RatingHistory');

delete from tasks where (TKNAME='GL_GET_REC_PROD');
delete from tasks where (TKNAME='GL_GET_REC_PROD_FR_LIST');
delete from tasks where (TKNAME='REC_PROD_DSP');
delete from tasks where (TKNAME='GL_REMOVE_PROD_RATINGS');
delete from tasks where (TKNAME='PROFILE_UPD_ATTR');
delete from tasks where (TKNAME='SELECT_UNRATED_PRODUCTS');
delete from tasks where (TKNAME='GET_RATING_HISTORY');

delete from ofs where (NAME='GL_ProfileUpdProd' and VERSION=1.0 and VENDOR='IBM' and PRODUCT='NC');
delete from ofs where (NAME='GL_ProfileUpdAttr' and VERSION=1.0 and VENDOR='IBM' and PRODUCT='NC');
delete from ofs where (NAME='GL_GetRecProd' and VERSION=1.0 and VENDOR='IBM' and PRODUCT='NC');
delete from ofs where (NAME='GL_RemoveProdRatings' and VERSION=1.0 and VENDOR='IBM' and PRODUCT='NC');
delete from ofs where (NAME='GL_GetRecProdFrList' and VERSION=1.0 and VENDOR='IBM' and PRODUCT='NC');
delete from ofs where (NAME='GL_ProfileSelectUnratedProd' and VERSION=1.0 and VENDOR='IBM' and PRODUCT='NC');
delete from ofs where (NAME='GL_GetRatingHistory' and VERSION=1.0 and VENDOR='IBM' and PRODUCT='NC');

echo;
echo RateProduct command;
echo;


insert into cmds (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, URL, EXPORT, DESCRIPTION) 
	values ((select max(REFNUM) from cmds)+1, 'pers_server_cmd.dll', 'IBM', 'NC', 'RateProduct', 1, 'RateProduct', 1, 'Explicit profiling.');

echo;
echo RecommendProduct command;
echo;


insert into cmds (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, URL, EXPORT, DESCRIPTION) 
	values ((select max(REFNUM) from cmds)+1, 'pers_server_cmd.dll', 'IBM', 'NC', 'RecommendProduct', 1, 'RecommendProduct', 1, 'Get list of recommended products');

echo;
echo RemoveProdRatings command;
echo;

insert into cmds (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, URL, EXPORT, DESCRIPTION) 
	values ((select max(REFNUM) from cmds)+1, 'pers_server_cmd.dll', 'IBM', 'NC', 'RemoveProdRatings', 1, 'RemoveProdRatings', 1, 'Delete all ratings for a product when a product is removed from the database');

echo;
echo EnterMerchant command;
echo;

insert into cmds (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, URL, EXPORT, DESCRIPTION) 
	values ((select max(REFNUM) from cmds)+1, 'pers_server_cmd.dll', 'IBM', 'NC', 'EnterMerchant', 1, 'EnterMerchant', 1, 'Enter the Your store');

echo;
echo CrossSellMerchant command;
echo;

insert into cmds (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, URL, EXPORT, DESCRIPTION) 
	values ((select max(REFNUM) from cmds)+1, 'pers_server_cmd.dll', 'IBM', 'NC', 'CrossSellMerchant', 1, 'CrossSellMerchant', 1, 'Display store specials');

echo;
echo PersonalizationCenter command;
echo;

insert into cmds (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, URL, EXPORT, DESCRIPTION) 
	values ((select max(REFNUM) from cmds)+1, 'pers_server_cmd.dll', 'IBM', 'NC', 'PersonalizationCenter', 1, 'PersonalizationCenter', 1, 'Personalization Center for the Your store');

commit;

echo;
echo RatingHistory command;
echo;

insert into cmds (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, URL, EXPORT, DESCRIPTION) 
	values ((select max(REFNUM) from cmds)+1, 'pers_server_cmd.dll', 'IBM', 'NC', 'RatingHistory', 1, 'RatingHistory', 1, 'Rating History for the Your store');

commit;

echo;
echo GL_GET_REC_PROD task;
echo;

insert into tasks (TKRFNBR, TKNAME, TKCOMMENT, TKGROUP, TKSCOPE) 
    values ((select max(TKRFNBR) from tasks)+1, 'GL_GET_REC_PROD', 'Get recommended products list from GroupLens', 'PROCESS', 1);

echo;
echo GL_GET_REC_PROD_FR_LIST task;
echo;

insert into tasks (TKRFNBR, TKNAME, TKCOMMENT, TKGROUP, TKSCOPE) 
    values ((select max(TKRFNBR) from tasks)+1, 'GL_GET_REC_PROD_FR_LIST', 'Get recommended products list from GroupLens given a list of products', 'PROCESS', 1);

echo;
echo REC_PROD_DSP task;
echo;

insert into tasks (TKRFNBR, TKNAME, TKCOMMENT, TKGROUP, TKSCOPE) 
    values ((select max(TKRFNBR) from tasks)+1, 'REC_PROD_DSP', 'Display list of recommended products', 'VIEW', 1);

echo;
echo GL_REMOVE_PROD_RATINGS task;
echo;

insert into tasks (TKRFNBR, TKNAME, TKCOMMENT, TKGROUP, TKSCOPE) 
    values ((select max(TKRFNBR) from tasks)+1, 'GL_REMOVE_PROD_RATINGS', 'Remove ratings for a product', 'PROCESS', 1);

echo;
echo PROFILE_UPD_ATTR task;
echo;

insert into tasks (TKRFNBR, TKNAME, TKCOMMENT, TKGROUP, TKSCOPE) 
    values ((select max(TKRFNBR) from tasks)+1, 'PROFILE_UPD_ATTR', 'Add profiling data based on product attributes', 'PROCESS', 1);

echo;
echo SELECT_UNRATED_PRODUCTS task;
echo;

insert into tasks (TKRFNBR, TKNAME, TKCOMMENT, TKGROUP, TKSCOPE) 
    values ((select max(TKRFNBR) from tasks)+1, 'SELECT_UNRATED_PRODUCTS', 'Remove rated products from a given list', 'PROCESS', 1);


echo;
echo GET_RATING_HISTORY task;
echo;

insert into tasks (TKRFNBR, TKNAME, TKCOMMENT, TKGROUP, TKSCOPE) 
    values ((select max(TKRFNBR) from tasks)+1, 'GET_RATING_HISTORY', 'Get a list of all explicitly rated products and their ratings', 'PROCESS', 1);

commit;

echo;
echo GL_ProfileUpdProd overridable function;
echo;

insert into ofs (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, DESCRIPTION)
    values ((select max(REFNUM) from ofs)+1, 'gl_server_api.dll', 'IBM', 'NC', 'GL_ProfileUpdProd', 1, 'Update GroupLens database for profiling info');

echo;
echo GL_ProfileUpdAttr overridable function;
echo;

insert into ofs (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, DESCRIPTION)
    values ((select max(REFNUM) from ofs)+1, 'gl_server_api.dll', 'IBM', 'NC', 'GL_ProfileUpdAttr', 1, 'Update GroupLens database for profiling info on a product attribute');

echo;
echo GL_GetRecProd overridable function;
echo;

insert into ofs (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, DESCRIPTION)
    values ((select max(REFNUM) from ofs)+1, 'gl_server_api.dll', 'IBM', 'NC', 'GL_GetRecProd', 1, 'Get a list of recommended products from GroupLens');

commit;

echo;
echo GL_RemoveProdRatings overridable function;
echo;

insert into ofs (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, DESCRIPTION)
    values ((select max(REFNUM) from ofs)+1, 'gl_server_api.dll', 'IBM', 'NC', 'GL_RemoveProdRatings', 1, 'Remove a products ratings when the product is deleted');

echo;
echo GL_GetRecProdFrList overridable function;
echo;

insert into ofs (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, DESCRIPTION)
    values ((select max(REFNUM) from ofs)+1, 'gl_server_api.dll', 'IBM', 'NC', 'GL_GetRecProdFrList', 1, 'Get product recommendations only for products in a given list');

commit;

echo;
echo GL_ProfileSelectUnratedProd overridable function;
echo;

insert into ofs (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, DESCRIPTION)
    values ((select max(REFNUM) from ofs)+1, 'gl_server_api.dll', 'IBM', 'NC', 'GL_ProfileSelectUnratedProd', 1, 'Remove rated products from a given list');

commit;

echo;
echo GL_GetRatingHistory overridable function;
echo;

insert into ofs (REFNUM, DLL_NAME, VENDOR, PRODUCT, NAME, VERSION, DESCRIPTION)
    values ((select max(REFNUM) from ofs)+1, 'gl_server_api.dll', 'IBM', 'NC', 'GL_GetRatingHistory', 1, 'Get ratings from recommendation database');

commit;

echo;
echo Link these guys together. . . .;
echo;

insert into pool_cmd (POOL_RN, CMD_RN) values ((select refnum from pools where name='ncommerce'), (select refnum from cmds where name='RateProduct'));
insert into pool_cmd (POOL_RN, CMD_RN) values ((select refnum from pools where name='ncommerce'), (select refnum from cmds where name='RecommendProduct'));
insert into pool_cmd (POOL_RN, CMD_RN) values ((select refnum from pools where name='ncommerce'), (select refnum from cmds where name='RemoveProdRatings'));
insert into pool_cmd (POOL_RN, CMD_RN) values ((select refnum from pools where name='ncommerce'), (select refnum from cmds where name='EnterMerchant'));
insert into pool_cmd (POOL_RN, CMD_RN) values ((select refnum from pools where name='ncommerce'), (select refnum from cmds where name='CrossSellMerchant'));
insert into pool_cmd (POOL_RN, CMD_RN) values ((select refnum from pools where name='ncommerce'), (select refnum from cmds where name='RatingHistory'));
insert into pool_cmd (POOL_RN, CMD_RN) values ((select refnum from pools where name='ncommerce'), (select refnum from cmds where name='PersonalizationCenter'));

commit;

insert into acc_mode (REFNUM, CMD_REFNUM, SSL, PROTECT) values (((select max(REFNUM) from acc_mode)+1), (select refnum from cmds where name='RateProduct'), 0, 0);
insert into acc_mode (REFNUM, CMD_REFNUM, SSL, PROTECT) values (((select max(REFNUM) from acc_mode)+1), (select refnum from cmds where name='RecommendProduct'), 0, 0);
insert into acc_mode (REFNUM, CMD_REFNUM, SSL, PROTECT) values (((select max(REFNUM) from acc_mode)+1), (select refnum from cmds where name='RemoveProdRatings'), 1, 1);
insert into acc_mode (REFNUM, CMD_REFNUM, SSL, PROTECT) values (((select max(REFNUM) from acc_mode)+1), (select refnum from cmds where name='EnterMerchant'), 0, 0);
insert into acc_mode (REFNUM, CMD_REFNUM, SSL, PROTECT) values (((select max(REFNUM) from acc_mode)+1), (select refnum from cmds where name='CrossSellMerchant'), 0, 0);
insert into acc_mode (REFNUM, CMD_REFNUM, SSL, PROTECT) values (((select max(REFNUM) from acc_mode)+1), (select refnum from cmds where name='RatingHistory'), 0, 0);
insert into acc_mode (REFNUM, CMD_REFNUM, SSL, PROTECT) values (((select max(REFNUM) from acc_mode)+1), (select refnum from cmds where name='PersonalizationCenter'), 0, 0);

commit;

