#ifndef _sample_h_
#define _sample_h_
/*********************************************************************/
/*                                                                   */
/* IBM Confidential                                                  */
/*                                                                   */
/* Net.Commerce Source Materials                                     */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996.                                     */
/*                                                                   */
/* The source code for this program is not published or otherwise    */
/* divested of its trade secrets, irrespective of what has been      */
/* deposited with the U.S. Copyright Office.                         */
/*                                                                   */
/*********************************************************************/

// To use this class template:
//  - Copy this file and its .cpp correspondant to files with your command name
//  - On both files, do a search on 'MyCommand' and replace with 'xxx' where xx is your command
//   class name.
//  - Follow comments on each function to customize.

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// User Command : MyCommand.
//
///////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ MyCommand : public NC_Command
 {
   static ClassName _STR_ThisClass;

   public:
    //  The command's constructor. Only initialize storage here, not state. The Initialization
    // method will be called shortly for that purpose. You can have any parameters you want.
    MyCommand(.......);

    //  State initialization. Called after all other commands have been loaded. At this point, you
    // can assume that the environment has been set-up properly, and that all other objects
    // (commands and APIs) exist (although they might not have been initialized yet). Database
    // connections,, ConfFile data etc... are available.
    //  If for some reason you cannot do your stuff, return 'false', and your command will be
    // deleted automatically. Otherwise, return 'true' to indicate a successful initialization.
    //  This method is called during server initialization, and therefore, should be cmall and
    // fast to execute. Otherwise, you are delaying the server accessibility for everyone.
    // Implementing this method is not mandatory. The default implementation simply returns true.
    virtual bool Initialize(void);

    // Destructor called at server shutdown (unless the server dies unexpectedly of course).
    virtual MyCommand();

    //  Make sure that you have your local delete operator. That way, the manager can delete
    // this command, and make sure that the delete compiled in with your command is called,
    // instead of the one compiled in with the command manager (they might be different).
    void  operator delete( void* p ) { ::delete p; }

   public:
    //  If your command cannot be registered, this function will be called before you are deleted.
    // RegId is the RegistrationID that was passed to the command manager during the registration
    // of your command.
    //  This method is called during server initialization, and therefore, should be cmall and
    // fast to execute. Otherwise, you are delaying the server accessibility for everyone.
    // Implementing this method is not mandatory. The default implementation simply returns true.
    virtual void FailedRegistration(NC_RegistrationID& RegID, const ErrorMsg_Reg* Err);

    //  Checks the input parameters for the command, and returns whether or not the parameters are
    // OK. In the process, establishes a list of merchant resources that will be accessed by the
    // command. This is crucial information, used for access control. If the set is empty, it is
    // assumed by the system that the command will not access any merchant resource.
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);

    //  Actual processing for the command. This is the meat of the logic of your command, where
    // you manipulate Commerce.Objects, access the database, call APIs etc...
    virtual bool Process (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };

#endif


