#ifndef _NOTIFY_H_
#define _NOTIFY_H_
/*********************************************************************/
/*                                                                   */
/* IBM Confidential                                                  */
/*                                                                   */
/* Net.Commerce Source Materials                                     */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996.                                     */
/*                                                                   */
/* The source code for this program is not published or otherwise    */
/* divested of its trade secrets, irrespective of what has been      */
/* deposited with the U.S. Copyright Office.                         */
/*                                                                   */
/*********************************************************************/


/////////////////////////////////////////////////////////////////////////////////////////////////////
// File:          notify.h
// User Command : Notify.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////

class __DLL_NCS_CMD__ CommandNotify : public NC_Command
 {
   static ClassName _STR_ThisClass;

   OrderHome _OrderHome;
   Order*    _Order;


   public:
	  CommandNotify() : 
      _OrderHome(*(DataBaseManager::GetCurrentDataBase())),
      _Order(NULL)
      { }
    void  operator delete( void* p ) { ::delete p; }

   private:
    String  _OrderRefNum;
	String  _url;
    String  _MerTemplate;
    String  _ShopperTemplate;
	String  _Parameters;
    NameValuePairMap  _NVPMap  ;

	String ResolveTemplateNameFromId (String Id, String merchant_rn);
	bool   BuildMessage              (const HttpRequest& Req,     const String Template, 
		                              const String merchant_rn,         String* Msg);
    bool   SendMsg                   (const String & MsgContents, const String& Subject, 
		                              const String& UserName,     const String & UserEmail);
    virtual bool CheckParameters     (const HttpRequest& Req, HttpResponse& Res,
                                            NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process             (const HttpRequest& Req, HttpResponse& Res, 
	                                        NC_Environment& Env);

 };

#endif


