#ifndef _ORDER_PROCESS_H_
#define _ORDER_PROCESS_H_
/*********************************************************************/
/*                                                                   */
/* IBM Confidential                                                  */
/*                                                                   */
/* Net.Commerce Source Materials                                     */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996.                                     */
/*                                                                   */
/* The source code for this program is not published or otherwise    */
/* divested of its trade secrets, irrespective of what has been      */
/* deposited with the U.S. Copyright Office.                         */
/*                                                                   */
/*********************************************************************/

// To use this class template:
//  - Copy this file and its .cpp correspondant to files with your command name
//  - On both files, do a search on 'CommandOrderProcess' and replace with 'xxx' where xx is your command class name.
//  - Follow comments on each function to customize.

// f 26383 tacktong 08/13/98 add new static function ProfileOrder for profiling the products in an order


// f 30809 moving functions for Order notification to that level to use them in etill.

/////////////////////////////////////////////////////////////////////////////////////////////////////
// File:          order_process.cpp
// User Command : CommandOrderProcess.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
#define ID_TEMPL_AUTHORIZED "3"
#define ID_TEMPL_AVSFAILED	"4"
#define ID_TEMPL_RECEIVED_OFFLINE	"5"


class __DLL_NCS_CMD__ CommandOrderProcess : public NC_Command
{
  static ClassName _STR_ThisClass;
  OrderHome      _OrderHome;
  OrderItemHome  _OrderItemHome;
  AddressHome    _AddressHome;

  User*          _User;
  Order*         _Order;

  String         _ShopperRefNum;
  String         _OrderRefNum;
  String         _BillToRefNum;

  String _Field1;
  String _Field2;
  String _Field3;

  public:
    CommandOrderProcess() :
      _OrderHome(*(DataBaseManager::GetCurrentDataBase())),
      _OrderItemHome(*(DataBaseManager::GetCurrentDataBase())),
      _AddressHome(*(DataBaseManager::GetCurrentDataBase())),
      _User(NULL), _Order(NULL),
      _ShopperRefNum(), _OrderRefNum(), _BillToRefNum(),
      _Field1(), _Field2(), _Field3()
      { }

   ~CommandOrderProcess();
   void  operator delete( void* p ) { ::delete p; }

   // The following are API wrapper function used by OrderProcess command
   // They are static so they may be used by similar commands
   static bool UpdateInventory(const Order *order, const HttpRequest& Req, 
                               HttpResponse& Res, NC_Environment& Env);

   static void CommandOrderProcess::PayOrderNotify(String OrderRefNum, HttpResponse& Res,
					 NC_Environment& Env, String idTempl, bool isMerchantNotify=false );

   static bool ReverseUpdateInventory(const Order *order, const HttpRequest& Req, 
                                      HttpResponse& Res, NC_Environment& Env);   

   static bool DoPayment      (const Order *order, const HttpRequest& Req,
                               HttpResponse& Res, NC_Environment& Env);

   static bool ExtendOrderProcess(const Order *order, const HttpRequest& Req,
                                  HttpResponse& Res, NC_Environment& Env);
   
   // f26383 starts
   static bool ProfileOrder(const Order *order, const HttpRequest& Req, 
                               HttpResponse& Res, NC_Environment& Env);
   // f26383 ends


public:
   virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                NC_Environment& Env, NC_Environment& Resources);
   virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
};

#endif


