/****************************************************************************************/
/*                                                                                      */
/* IBM Confidential                                                                     */
/*                                                                                      */
/* Net.Commerce Source Materials                                                        */
/*                                                                                      */
/* (C) Copyright IBM Corp. 1996, 1997.                                                  */
/*                                                                                      */
/* The source code for this program is not published or otherwise divested of its trade */
/* secrets, irrespective of what has been deposited with the U.S. Copyright Office.     */
/*                                                                                      */
/****************************************************************************************/

#ifndef _ORDERITEM_UPDATE_H_
#define _ORDERITEM_UPDATE_H_

/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// User Command : CommandOrderItemUpdate.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ CommandOrderItemUpdate : public NC_Command
{
   static const ClassName _STR_ThisClass;

public:
   CommandOrderItemUpdate() : _quantity(), _addr_rn(), _orderitem_rn(), _product_rn(), 
      _shipmode_rn(), _comment(), _field1(), _field2() { }
   ~CommandOrderItemUpdate() {  }

   void  operator delete( void* p ) { ::delete p; }

public:
   virtual bool CheckParameters( const HttpRequest& Req, 
                                 HttpResponse& Res,
                                 NC_Environment& Env, 
                                 NC_Environment& Resources );
   virtual bool Process( const HttpRequest& Req,
                         HttpResponse& Res, 
                         NC_Environment& Env );

private:
   bool CheckInventory( const HttpRequest& Req, 
                        HttpResponse& Res, 
                        NC_Environment& Env, 
                        const String& MerchantRefNum,
                        const String& ProductRefNum );

private:
   // Url Name Value Pairs:
   String _quantity;
   String _addr_rn;
   String _orderitem_rn;
   String _product_rn;
   String _shipmode_rn;
   String _comment;
   String _field1;
   String _field2;
};


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// User Command : CommandOrderShippingUpdate.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ CommandOrderShippingUpdate : public NC_Command
{
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;
   #endif

public:
   CommandOrderShippingUpdate() : _order_rn(), _addr_rn(), _shipmode_rn() { }
   ~CommandOrderShippingUpdate() {  }

   void  operator delete( void* p ) { ::delete p; }

public:
   virtual bool CheckParameters( const HttpRequest& Req, 
                                 HttpResponse& Res,
                                 NC_Environment& Env, 
                                 NC_Environment& Resources );
   virtual bool Process( const HttpRequest& Req,
                         HttpResponse& Res, 
                         NC_Environment& Env );

private:
   // Url Name Value Pairs:
   String _order_rn;
   String _addr_rn;
   String _shipmode_rn;
};

#endif

