#ifndef _SCHED_CMDS_H_
#define _SCHED_CMDS_H_
/*********************************************************************/
/*                                                                   */
/* IBM Confidential                                                  */
/*                                                                   */
/* Net.Commerce Source Materials                                     */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996.                                     */
/*                                                                   */
/* The source code for this program is not published or otherwise    */
/* divested of its trade secrets, irrespective of what has been      */
/* deposited with the U.S. Copyright Office.                         */
/*                                                                   */
/*********************************************************************/


/////////////////////////////////////////////////////////////////////////////////////////////////////
// File:          sched_cmds.h
// User Command : AddJob, RemoveJob
//
/////////////////////////////////////////////////////////////////////////////////////////////////////

class __DLL_NCS_CMD__ CommandAddJob : public NC_Command
 {
   static ClassName _STR_ThisClass;

   SchConfigHome _ConfigHome;
   SchConfig*    _Config;
   SchStatusHome _StatusHome;
   SchStatus*    _Status;
   UserHome      _UserHome;
   User*         _User;


   public:
	  CommandAddJob() : 
      _ConfigHome(*(DataBaseManager::GetCurrentDataBase())),
      _StatusHome(*(DataBaseManager::GetCurrentDataBase())),
      _UserHome(*(DataBaseManager::GetCurrentDataBase()))
      { }
    void  operator delete( void* p ) { ::delete p; }

   private:
	String  _UserName;
	String  _UserRefNum;
	String  _StartTime;
    String  _CommandName;
	String  _Url;
    String  _QueryString;
	String  _HostName;
    String  _Interval;
	String  _Priority;
    String  _RecoveryAttempts;
	String  _RecoveryDelay;
	String  year;
    String  month;
    String  day;
    String  hour;
    String  minute;
    String  second;
	String  _RefNum;
    NVPHash NVP;



    virtual bool CheckParameters     (const HttpRequest& Req, HttpResponse& Res,
                                            NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process             (const HttpRequest& Req, HttpResponse& Res, 
	                                        NC_Environment& Env);

 };


class __DLL_NCS_CMD__ CommandRemoveJob : public NC_Command
 {
   static ClassName _STR_ThisClass;

   SchConfigHome _ConfigHome;
   SchConfig*    _Config;
   SchStatusHome _StatusHome;
   SchStatus*    _Status;

   public:
	  CommandRemoveJob() : 
      _StatusHome(*(DataBaseManager::GetCurrentDataBase())),
      _ConfigHome(*(DataBaseManager::GetCurrentDataBase()))
      { }
    void  operator delete( void* p ) { ::delete p; }

   private:
	String  _JobRefNum;
	String  _Url;

    virtual bool CheckParameters     (const HttpRequest& Req, HttpResponse& Res,
                                            NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process             (const HttpRequest& Req, HttpResponse& Res, 
	                                        NC_Environment& Env);
};

#endif


