#ifndef _SQL_PCH_
#define _SQL_PCH_

/*********************************************************************/
/*                                                                   */
/* IBM Confidential                                                  */
/*                                                                   */
/* Net.Commerce Source Materials                                     */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996.                                     */
/*                                                                   */
/* The source code for this program is not published or otherwise    */
/* divested of its trade secrets, irrespective of what has been      */
/* deposited with the U.S. Copyright Office.                         */
/*                                                                   */
/*********************************************************************/


/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// User Command : CommandConnect.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ CommandConnect : public NC_Command
 {
   static const ClassName _STR_ThisClass;

   public:
    CommandConnect()   { }
    ~CommandConnect();

   protected:
     String _DBName;
     String _UserName;
     String _Password;

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };









/////////////////////////////////////////////////////////////////////////////////////////////////////
//
// User Command : CommandSQL.
//
/////////////////////////////////////////////////////////////////////////////////////////////////////
class __DLL_NCS_CMD__ CommandSQL : public NC_Command
 {
   static const ClassName _STR_ThisClass;

   public:
    CommandSQL() : _RowList(true)  { }
    void  operator delete( void* p ) { ::delete p; }

   protected:
    String                             _SqlStatement;
    bool                               _Local;
    TemplateNC_PList<String, String>  _RowList;

   public:
    virtual bool CheckParameters(const HttpRequest& Req, HttpResponse& Res,
                                 NC_Environment& Env, NC_Environment& Resources);
    virtual bool Process        (const HttpRequest& Req, HttpResponse& Res, NC_Environment& Env);
 };



#endif


