#ifndef _behavior_schema_h_
#define _behavior_schema_h_
/*********************************************************************/
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved   */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/
///////////////////////////////////////////////////////////////////////
// This file is part of Net.Commerce                                 //
// Header file for Behavior.                                               //
///////////////////////////////////////////////////////////////////////




class StaticSQL;

class __DLL_NCS_OBJ__ Behavior : public SQL_Schema
 { 
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL; 
   friend class BehaviorHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
     // Database against which the object is used. If LoadAll is true, the object loads 
     //all fields at once. Otherwise, loads the minimum set, and will load the others 
     //on demand
    Behavior(DataBase& DB, bool LoadAll=true);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME      ;
    static const StringWithOwnership _COL_REF_NUM    ;
    static const StringWithOwnership _COL_NAME       ;
    static const StringWithOwnership _COL_DESCRIPTION;

   public: // Get functions
    const String& getRefNum     (bool Real=true);
    const String& getName       (bool Real=true);
    const String& getDescription(bool Real=true);

   public: // Set functions
    void setRefNum     (const String& RefNum     );
    void setName       (const String& Name       );
    void setDescription(const String& Description);
 };



class __DLL_NCS_OBJ__ BehaviorHome : public SQL_SchemaMap<Behavior>
 { 
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging 
   static const FuncName  _STR_Create; 
   static const FuncName  _STR_Lookup; 

   public: 
    BehaviorHome(DataBase& DB)  : SQL_SchemaMap<Behavior>(DB) { }


   public: 
    Behavior* Create(const String& Name, const NVPHash& NameValuePairs);
    Behavior* Lookup(const String& RefNum, const NVPHash& NameValuePairs);
    Behavior* LookupByName(const String& Name, const NVPHash& NameValuePairs);
 };






#endif

