#ifndef _billitems_schema_h_
#define _billitems_schema_h_
/*********************************************************************/
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved   */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/
///////////////////////////////////////////////////////////////////////
// This file is part of Net.Commerce                                 //
// Header file for BillItems.                                               //
///////////////////////////////////////////////////////////////////////




class StaticSQL;

class __DLL_NCS_OBJ__ BillItems : public SQL_Schema
 { 
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL; 
   friend class BillItemsHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
     // Database against which the object is used. If LoadAll is true, the object loads 
     //all fields at once. Otherwise, loads the minimum set, and will load the others 
     //on demand
    BillItems(DataBase& DB, bool LoadAll=true);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME      ;
    static const StringWithOwnership _COL_REF_NUM    ;
    static const StringWithOwnership _COL_ITEM       ;
    static const StringWithOwnership _COL_VALTYPE    ;
    static const StringWithOwnership _COL_DESCRIPTION;

   public: // Get functions
    const String& getRefNum     (bool Real=true);
    const String& getBillitem   (bool Real=true);
    const String& getBillvaltype(bool Real=true);
    const String& getBillitdesc (bool Real=true);

   public: // Set functions
    void setRefNum     (const String& RefNum     ) { SQL_Schema::setValue(_COL_REF_NUM    ,RefNum     ); }
    void setBillitem   (const String& Billitem   ) { SQL_Schema::setValue(_COL_ITEM       ,Billitem   ); }
    void setBillvaltype(const String& Billvaltype) { SQL_Schema::setValue(_COL_VALTYPE    ,Billvaltype); }
    void setBillitdesc (const String& Billitdesc ) { SQL_Schema::setValue(_COL_DESCRIPTION,Billitdesc ); }
 };



class __DLL_NCS_OBJ__ BillItemsHome : public SQL_SchemaMap<BillItems>
 { 
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging 
   static const FuncName  _STR_Create; 
   static const FuncName  _STR_Lookup; 

   public: 
    BillItemsHome(DataBase& DB)  : SQL_SchemaMap<BillItems>(DB) { }


   public: 
    BillItems* Create(const NVPHash& NameValuePairs);
    BillItems* Lookup(const NVPHash& NameValuePairs);
 };



class __DLL_NCS_OBJ__ BillItemsNVP : public NC_Void
 { 
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
       static const StringWithOwnership _NVP_REF_NUM ;

   public: 
    static bool CreateSchemaNVP(const HttpRequest& Req, NC_Environment& Env,
                                const String& ErrorTask, const String& MerchantRefNum,
                                NVPHash& NameValuePairs
                               );
    static void SetThroughNVP  (const HttpRequest& Req, BillItems* R);

 };



#endif

