#ifndef _cmbitems_schema_h_
#define _cmbitems_schema_h_
/*********************************************************************/
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved   */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/
///////////////////////////////////////////////////////////////////////
// This file is part of Net.Commerce                                 //
// Header file for CmbItems.                                               //
///////////////////////////////////////////////////////////////////////




class StaticSQL;

class __DLL_NCS_OBJ__ CmbItems : public SQL_Schema
 { 
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL; 
   friend class CmbItemsHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
     // Database against which the object is used. If LoadAll is true, the object loads 
     //all fields at once. Otherwise, loads the minimum set, and will load the others 
     //on demand
    CmbItems(DataBase& DB, bool LoadAll=true);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME        ;
    static const StringWithOwnership _COL_REF_NUM      ;
    static const StringWithOwnership _COL_CB_CBTRFNBR  ;
    static const StringWithOwnership _COL_CB_CBINTVAL  ;
    static const StringWithOwnership _COL_CB_CBCURVALUE;

   public: // Get functions
    const String& getMerchantRefNum(bool Real=true);
    const String& getCurMerBillItem(bool Real=true);
    const String& getCurMerCountVal(bool Real=true);
    const String& getCurMerVal    (bool Real=true);

   public: // Set functions
    void setMerchantRefNum(const String& MerchantRefNum) { SQL_Schema::setValue(_COL_REF_NUM      ,MerchantRefNum); }
    void setCurMerBillItem(const String& CurMerBillItem) { SQL_Schema::setValue(_COL_CB_CBTRFNBR  ,CurMerBillItem); }
    void setCurMerCountVal(const String& CurMerCountVal) { SQL_Schema::setValue(_COL_CB_CBINTVAL  ,CurMerCountVal); }
    void setCurMerVal    (const String& CurMerVal    ) { SQL_Schema::setValue(_COL_CB_CBCURVALUE,CurMerVal    ); }
 };



class __DLL_NCS_OBJ__ CmbItemsHome : public SQL_SchemaMap<CmbItems>
 { 
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging 
   static const FuncName  _STR_Create; 
   static const FuncName  _STR_Lookup; 

   public: 
    CmbItemsHome(DataBase& DB)  : SQL_SchemaMap<CmbItems>(DB) { }


   public: 
    CmbItems* Create(const NVPHash& NameValuePairs);
    CmbItems* Lookup(const NVPHash& NameValuePairs);
 };



class __DLL_NCS_OBJ__ CmbItemsNVP : public NC_Void
 { 
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
       static const StringWithOwnership _NVP_REF_NUM   ;

   public: 
    static bool CreateSchemaNVP(const HttpRequest& Req, NC_Environment& Env,
                                const String& ErrorTask, const String& MerchantRefNum,
                                NVPHash& NameValuePairs
                               );
    static void SetThroughNVP  (const HttpRequest& Req, CmbItems* R);

 };



#endif

