
/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996, 1998. All Rights Reserved           */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA, ADP Schedule Contract with IBM Corp.*/
/*                                                                   */
/*********************************************************************/

class __DLL_NCS_OBJ__ StaticSQL
{
public:
   static const StringWithOwnership _STR_DB2;

public:
   static Address* AddressLookup( Address* obj,
                                  long& _Error,
                                  const String& ref_num );
   static Category* CategoryLookup( Category* obj,
                                    long& _Error,
                                    const String& ref_num );
   static CategoryView* CategoryViewLookup( CategoryView* obj,
                                            long& _Error,
                                            const String& merchant_ref_num,
                                            const String& category_ref_num,
                                            const String& shopper_group_ref_num );
   static Destination* DestinationLookup( Destination* obj,
                                          long& _Error,
                                          const String& order_ref_num,
                                          const String& address_ref_num );
   static InterestItem* InterestItemLookup( InterestItem* obj,
                                            long& _Error,
                                            const String& shopper_ref_num,
                                            const String& product_ref_num );
   static Merchant* MerchantLookup( Merchant* obj,
                                    long& _Error,
                                    const String& ref_num );
   static MerchantUserInfo* MerchantUserInfoLookup( MerchantUserInfo* obj,
                                                    long& _Error,
                                                    const String& shopper_ref_num,
                                                    const String& merchant_ref_num );
   static Order* OrderLookup( Order* obj,
                              long& _Error,
                              const String& ref_num );
   static OrderItem* OrderItemLookup( OrderItem* obj,
                                      long& _Error,
                                      const String& ref_num );
   static Product* ProductLookup( Product* obj,
                                  long& _Error,
                                  const String& ref_num );
   static ProductAttribute* ProductAttributeLookup( ProductAttribute* obj,
                                                    long& _Error,
                                                    const String& name );
   static ProductPrice* ProductPriceLookup( ProductPrice* obj,
                                            long& _Error,
                                            const String& ref_num );
   static ProductView* ProductViewLookup( ProductView* obj,
                                          long& _Error,
                                          const String& merchant_ref_num,
                                          const String& product_ref_num,
                                          const String& shopper_group_ref_num );
   static SkuAttributeValue* SkuAttributeValueLookup( SkuAttributeValue* obj,
                                                      long& _Error,
                                                      const String& name,
                                                      const String& sku_ref_num );
   static SKU_Hard* SKU_HardLookup( SKU_Hard* obj,
                                    long& _Error,
                                    const String& ref_num );
   static User* UserLookup( User* obj,
                            long& _Error,
                            const String& ref_num );
   static UserGroup* UserGroupLookup( UserGroup* obj,
                                      long& _Error,
                                      const String& ref_num );
   static Address* AddressLookupCurrentFromNickname( Address* obj,
                                                     long& _Error,
                                                     const String& shopper_ref_num,
                                                     const String& nickname,
                                                     const String& flag );
   static User* UserLookupByName( User* obj,
                                  long& _Error,
                                  const String& id );
};


