#ifndef _hmbitems_schema_h_
#define _hmbitems_schema_h_
/*********************************************************************/
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (c)  Copyright  IBM Corp.  1998, 1999.      All Rights Reserved   */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA ADP Schedule Contract with IBM Corp. */
/*********************************************************************/
///////////////////////////////////////////////////////////////////////
// This file is part of Net.Commerce                                 //
// Header file for HmbItems.                                               //
///////////////////////////////////////////////////////////////////////




class StaticSQL;

class __DLL_NCS_OBJ__ HmbItems : public SQL_Schema
 { 
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL; 
   friend class HmbItemsHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
     // Database against which the object is used. If LoadAll is true, the object loads 
     //all fields at once. Otherwise, loads the minimum set, and will load the others 
     //on demand
    HmbItems(DataBase& DB, bool LoadAll=true);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME        ;
    static const StringWithOwnership _COL_REF_NUM      ;
    static const StringWithOwnership _COL_HIST_TRFNBR  ;
    static const StringWithOwnership _COL_HIST_INTVALUE;
    static const StringWithOwnership _COL_HIST_CURVALUE;
    static const StringWithOwnership _COL_HIST_HBCUR   ;
    static const StringWithOwnership _COL_HIST_FROMSTMP;
    static const StringWithOwnership _COL_HIST_TOSTMP  ;

   public: // Get functions
    const String& getMerchantRefNum   (bool Real=true);
    const String& getHistMerBillItem  (bool Real=true);
    const String& getHistMerCountVal  (bool Real=true);
    const String& getHistMerVal      (bool Real=true);
    const String& getHistMerCurrency  (bool Real=true);
    const String& getHistFromTimeStamp(bool Real=true);
    const String& getHistToTimeStamp  (bool Real=true);

   public: // Set functions
    void setMerchantRefNum   (const String& MerchantRefNum   ) { SQL_Schema::setValue(_COL_REF_NUM      ,MerchantRefNum   ); }
    void setHistMerBillItem  (const String& HistMerBillItem  ) { SQL_Schema::setValue(_COL_HIST_TRFNBR  ,HistMerBillItem  ); }
    void setHistMerCountVal  (const String& HistMerCountVal  ) { SQL_Schema::setValue(_COL_HIST_INTVALUE,HistMerCountVal  ); }
    void setHistMerVal      (const String& HistMerVal      ) { SQL_Schema::setValue(_COL_HIST_CURVALUE,HistMerVal      ); }
    void setHistMerCurrency  (const String& HistMerCurrency  ) { SQL_Schema::setValue(_COL_HIST_HBCUR   ,HistMerCurrency  ); }
    void setHistFromTimeStamp(const String& HistFromTimeStamp) { SQL_Schema::setValue(_COL_HIST_FROMSTMP,HistFromTimeStamp); }
    void setHistToTimeStamp  (const String& HistToTimeStamp  ) { SQL_Schema::setValue(_COL_HIST_TOSTMP  ,HistToTimeStamp  ); }
 };



class __DLL_NCS_OBJ__ HmbItemsHome : public SQL_SchemaMap<HmbItems>
 { 
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging 
   static const FuncName  _STR_Create; 
   static const FuncName  _STR_Lookup; 

   public: 
    HmbItemsHome(DataBase& DB)  : SQL_SchemaMap<HmbItems>(DB) { }


   public: 
    HmbItems* Create(const NVPHash& NameValuePairs);
    HmbItems* Lookup(const NVPHash& NameValuePairs);
 };



class __DLL_NCS_OBJ__ HmbItemsNVP : public NC_Void
 { 
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif 

   public: 
       static const StringWithOwnership _NVP_REF_NUM   ;

   public: 
    static bool CreateSchemaNVP(const HttpRequest& Req, NC_Environment& Env,
                                const String& ErrorTask, const String& MerchantRefNum,
                                NVPHash& NameValuePairs
                               );
    static void SetThroughNVP  (const HttpRequest& Req, HmbItems* R);

 };



#endif

