/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996, 1998. All Rights Reserved           */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA, ADP Schedule Contract with IBM Corp.*/
/*                                                                   */
/*********************************************************************/

#ifndef _MERCHANTINFO_SCHEMA_H_
#define _MERCHANTINFO_SCHEMA_H_


/////////////////////////////////////////////////////////////////////////////////////////
//
//  MerchantInfo
//
//
class StaticSQL;

class __DLL_NCS_OBJ__ MerchantInfo : public SQL_Schema
{
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL;
   friend class MerchantInfoHome;

public:
   MerchantInfo(DataBase& DB);

public:
   // TABLE DEFINIFTION
   static const StringWithOwnership _COL_TNAME;
   static const StringWithOwnership _STR_T_NAME;

   // NOT NULL Fields
   static const StringWithOwnership _COL_MER_REF_NUM;

   // NULLable fields
   static const StringWithOwnership MerchantInfo::_COL_DOMAIN;
   static const StringWithOwnership MerchantInfo::_COL_ALIAS;
   static const StringWithOwnership MerchantInfo::_COL_DIR_NAME;
   static const StringWithOwnership MerchantInfo::_COL_META_LOCATION;
   static const StringWithOwnership MerchantInfo::_COL_META_TIMESTAMP;
   static const StringWithOwnership MerchantInfo::_COL_STATE;
   static const StringWithOwnership MerchantInfo::_COL_STATE_TIMESTAMP;
   static const StringWithOwnership MerchantInfo::_COL_PUBLISH;

   static const StringWithOwnership MerchantInfo::_COL_DBV_PUBLISHED;
   static const StringWithOwnership MerchantInfo::_COL_DBV_UNPUBLISHED;
   static const StringWithOwnership MerchantInfo::_COL_DBV_STATE_NEW;
   static const StringWithOwnership MerchantInfo::_COL_DBV_STATE_OPEN;
   static const StringWithOwnership MerchantInfo::_COL_DBV_STATE_CLOSED;
   static const StringWithOwnership MerchantInfo::_COL_DBV_STATE_LOCKED;



// Gets and Sets
public:
   void setDomain           (const String& s){ SQL_Schema::setValue(_COL_DOMAIN            , s); }
   void setAlias            (const String& s){ SQL_Schema::setValue(_COL_ALIAS             , s); }
   void setDirName          (const String& s){ SQL_Schema::setValue(_COL_DIR_NAME          , s); }
   void setMetaLoc          (const String& s){ SQL_Schema::setValue(_COL_META_LOCATION     , s); }
   void setMetaLastUpdate   (const String& s){ SQL_Schema::setValue(_COL_META_TIMESTAMP    , s); }
   void setState            (const String& s){ SQL_Schema::setValue(_COL_STATE             , s); }
   void setStateLastUpdate  (const String& s){ SQL_Schema::setValue(_COL_STATE_TIMESTAMP   , s); }
   void setPublished        (const String& s){ SQL_Schema::setValue(_COL_PUBLISH         , s); }


   const String& getMerRefNum       (void){ return SQL_Schema::getValue(_COL_MER_REF_NUM      ); }
   const String& getDomain          (void){ return SQL_Schema::getValue(_COL_DOMAIN           ); }
   const String& getAlias           (void){ return SQL_Schema::getValue(_COL_ALIAS            ); }
   const String& getDirName         (void){ return SQL_Schema::getValue(_COL_DIR_NAME         ); }
   const String& getMetaLoc         (void){ return SQL_Schema::getValue(_COL_META_LOCATION    ); }
   const String& getMetaLastUpdate  (void){ return SQL_Schema::getValue(_COL_META_TIMESTAMP   ); }
   const String& getState           (void){ return SQL_Schema::getValue(_COL_STATE            ); }
   const String& getStateLastUpdate (void){ return SQL_Schema::getValue(_COL_STATE_TIMESTAMP  ); }
   const String& getPublished       (void){ return SQL_Schema::getValue(_COL_PUBLISH          ); }
};


/////////////////////////////////////////////////////////////////////////////////////////
//
//  MerchantInfoHome
//
//

typedef TemplateNC_PList<MerchantInfo, String> MerchantInfoList;

class __DLL_NCS_OBJ__ MerchantInfoHome : public SQL_SchemaMap<MerchantInfo>
{
   typedef SQL_SchemaMap<MerchantInfo> _parent;

public:
   MerchantInfoHome(DataBase& db) : _parent(db) { }

public:
   MerchantInfo* Create( const String& MerchantRefNum,
                      const String& State,
                      const String& Published,
                      const NVPHash& NameValuePairs );

   MerchantInfo* Lookup(const String& MerRefNum, const NVPHash& NameValuePairs);

};

#endif

