

/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996, 1999. All Rights Reserved           */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA, ADP Schedule Contract with IBM Corp.*/
/*                                                                   */
/*********************************************************************/
//////////////////////////////////////////////////////////////////////////////////////////
// Change History
//////////////////////////////////////////////////////////////////////////////////////////
// YYMMDD  F/D#   WHO    Description
// ---------------------------------------------------------------------------------------
// 980727  d26082 lam    Catalog Architect.
//////////////////////////////////////////////////////////////////////////////////////////

#ifndef _PROD_ATTR_SCHEMA_H_
#define _PROD_ATTR_SCHEMA_H_



class StaticSQL;

class __DLL_NCS_OBJ__ ProductAttribute : public SQL_Schema
 {
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL;
   friend class ProductAttributeHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif

   public:
    ProductAttribute(DataBase& DB);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME             ;
    static const StringWithOwnership _COL_NAME              ;
    static const StringWithOwnership _COL_PRODUCT_REF_NUM   ;
    static const StringWithOwnership _COL_MERCHANT_REF_NUM  ;
    static const StringWithOwnership _COL_DESC1             ;
    static const StringWithOwnership _COL_DESC2             ;
    static const StringWithOwnership _COL_SEQUENCE          ;
// d26082 start
    static const StringWithOwnership _COL_OBJECT_ID         ;
// d26082 end

   public: // Get functions
    const String& getName          (bool Real=true) { return SQL_Schema::getValue(_COL_NAME            , Real); }
    const String& getProductRefNum (bool Real=true) { return SQL_Schema::getValue(_COL_PRODUCT_REF_NUM , Real); }
    const String& getMerchantRefNum(bool Real=true) { return SQL_Schema::getValue(_COL_MERCHANT_REF_NUM, Real); }
    const String& getDescription1  (bool Real=true) { return SQL_Schema::getValue(_COL_DESC1           , Real); }
    const String& getDescription2  (bool Real=true) { return SQL_Schema::getValue(_COL_DESC2           , Real); }
    const String& getSequence      (bool Real=true) { return SQL_Schema::getValue(_COL_SEQUENCE        , Real); }
// d26082 start
    const String& getObjectid     (bool Real=true) { return SQL_Schema::getValue(_COL_OBJECT_ID        , Real); }
// d26082 end

   public: // Set functions
    void setName          (const String& Name         ) { SQL_Schema::setValue(_COL_NAME              ,Name         ); }
    void setProductRefNum (const String& ProductRefNum) { SQL_Schema::setValue(_COL_PRODUCT_REF_NUM   ,ProductRefNum); }
    void setMerchantRefNum(const String& ProductRefNum) { SQL_Schema::setValue(_COL_MERCHANT_REF_NUM  ,ProductRefNum); }
    void setDescription1  (const String& Description1 ) { SQL_Schema::setValue(_COL_DESC1             ,Description1 ); }
    void setDescription2  (const String& Description2 ) { SQL_Schema::setValue(_COL_DESC2             ,Description2 ); }
    void setSequence      (const String& Sequence     ) { SQL_Schema::setValue(_COL_SEQUENCE          ,Sequence     ); }
// d26082 start
    void setObjectid 	 (const String& Objectid     ) { SQL_Schema::setValue(_COL_OBJECT_ID         ,Objectid     ); }
// d26082 end
 };



class __DLL_NCS_OBJ__ ProductAttributeHome : public SQL_SchemaMap<ProductAttribute>
 {
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif

   public:
    ProductAttributeHome(DataBase& DB) : SQL_SchemaMap<ProductAttribute>(DB) { }


   public:
    ProductAttribute* Create(const String& Name, const String& ProductRefNum, const String& MerchantRefNum,
                             const NVPHash& NameValuePairs);
    ProductAttribute* Create(const String& Name, const String& ProductRefNum, const String& MerchantRefNum);

    ProductAttribute* Lookup(const String& Name, const String& ProductRefNum,
                             const NVPHash& NameValuePairs);
    ProductAttribute* Lookup(const String& Name, const String& ProductRefNum);
 };


#endif

