
/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996, 1998. All Rights Reserved           */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA, ADP Schedule Contract with IBM Corp.*/
/*                                                                   */
/*********************************************************************/

#ifndef _TEMPLATE_SCHEMA_H_
#define _TEMPLATE_SCHEMA_H_


/////////////////////////////////////////////////////////////////////////////////////////
//
//  class Template
//

class StaticSQL;

class __DLL_NCS_OBJ__ Template : public SQL_Schema
{
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL;
   friend class TemplateHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif

public:
   Template(DataBase& DB);

public: // Schema column names
   static const StringWithOwnership _COL_TNAME            ;
   static const StringWithOwnership _COL_TEMPLATE_ID      ;
   static const StringWithOwnership _COL_MERCHANT_REF_NUM ;
   static const StringWithOwnership _COL_TEMPLATE_NAME    ;

public: // Get functions
   const String& getTemplateId        (bool Real=false) { return SQL_Schema::getValue(_COL_TEMPLATE_ID     , Real); }
   const String& getMerchantRefNum    (bool Real=false) { return SQL_Schema::getValue(_COL_MERCHANT_REF_NUM, Real); }
   const String& getTemplateName      (bool Real=false) { return SQL_Schema::getValue(_COL_TEMPLATE_NAME   , Real); }

public: // Set functions
   void setTemplateId      (const String& Id          )     { SQL_Schema::setValue(_COL_TEMPLATE_ID        ,Id             ); }
   void setMerchantRefNum  (const String& MerchantRefNum  ) { SQL_Schema::setValue(_COL_MERCHANT_REF_NUM   ,MerchantRefNum ); }
   void setTemplateName    (const String& Name            ) { SQL_Schema::setValue(_COL_TEMPLATE_NAME      ,Name           ); }
};


class __DLL_NCS_OBJ__ TemplateHome : public SQL_SchemaMap<Template>
{
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif

public:
   TemplateHome(DataBase& DB) : SQL_SchemaMap<Template>(DB) { }


public:
   Template* Create(const String& TemplateId, const String& MerchantRefNum, const String& TemplateName, const NVPHash& NameValuePairs);
   Template* Lookup(const String& TemplateId, const String& MerchantRefNum, const NVPHash& NameValuePairs);
};


#endif

