#ifndef _user_demog_schema_h_
#define _user_demog_schema_h_



/*********************************************************************/
/*                                                                   */
/* Licensed Materials - Property of IBM                              */
/*                                                                   */
/* 5697-D24                                                          */
/*                                                                   */
/* (C) Copyright IBM Corp. 1996, 1998. All Rights Reserved           */
/*                                                                   */
/* US Government Users Restricted Rights - Use, duplication or       */
/* disclosure restricted by GSA, ADP Schedule Contract with IBM Corp.*/
/*                                                                   */
/*********************************************************************/

class StaticSQL;

class __DLL_NCS_OBJ__ UserDemographics : public SQL_Schema
 {
   // These two lines are for the static SQL implementation.  They must be put in
   // all files that use this.
   friend class StaticSQL;
   friend class UserDemographicsHome;

   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif

   public:
     // Database against which the object is used. If LoadAll is true, the object loads
     //all fields at once. Otherwise, loads the minimum set, and will load the others
     //on demand
    UserDemographics(DataBase& DB, bool LoadAll=true);

   public: // Schema column names
    static const StringWithOwnership _COL_TNAME                    ;
    static const StringWithOwnership _COL_SHOPPER_REF_NUM          ;
    static const StringWithOwnership _COL_GENDER                   ;
       static const StringWithOwnership _VAL_GENDER_MALE           ;
       static const StringWithOwnership _VAL_GENDER_FEMALE         ;
       static const StringWithOwnership _VAL_GENDER_UNKNOWN        ;
    static const StringWithOwnership _COL_AGE                      ;
       static const StringWithOwnership _VAL_AGE_UNKNOWN           ;
       static const StringWithOwnership _VAL_AGE_OPTION1           ;
       static const StringWithOwnership _VAL_AGE_OPTION2           ;
       static const StringWithOwnership _VAL_AGE_OPTION3           ;
       static const StringWithOwnership _VAL_AGE_OPTION4           ;
       static const StringWithOwnership _VAL_AGE_OPTION5           ;
       static const StringWithOwnership _VAL_AGE_OPTION6           ;
       static const StringWithOwnership _VAL_AGE_OPTION7           ;
    static const StringWithOwnership _COL_INCOME                   ;
       static const StringWithOwnership _VAL_INCOME_UNKNOWN        ;
       static const StringWithOwnership _VAL_INCOME_OPTION1        ;
       static const StringWithOwnership _VAL_INCOME_OPTION2        ;
       static const StringWithOwnership _VAL_INCOME_OPTION3        ;
       static const StringWithOwnership _VAL_INCOME_OPTION4        ;
    static const StringWithOwnership _COL_MARITAL_STATUS           ;
       static const StringWithOwnership _VAL_MARITAL_STATUS_UNKNOWN;
       static const StringWithOwnership _VAL_MARITAL_STATUS_SINGLE ;
       static const StringWithOwnership _VAL_MARITAL_STATUS_MARRIED;
       static const StringWithOwnership _VAL_MARITAL_STATUS_COMMON_LAW;
       static const StringWithOwnership _VAL_MARITAL_STATUS_SEPARATED;
       static const StringWithOwnership _VAL_MARITAL_STATUS_DIVORCED;
       static const StringWithOwnership _VAL_MARITAL_STATUS_WIDOWED;
       static const StringWithOwnership _VAL_MARITAL_STATUS_OTHER  ;
    static const StringWithOwnership _COL_CHILDREN                 ;
    static const StringWithOwnership _COL_HOUSEHOLD                ;
    static const StringWithOwnership _COL_COMPANY                  ;
    static const StringWithOwnership _COL_INTERESTS                ;
    static const StringWithOwnership _COL_ALREADY_ORDERED          ;
       static const StringWithOwnership _VAL_ALREADY_ORDERED_YES   ;
       static const StringWithOwnership _VAL_ALREADY_ORDERED_NO    ;
    static const StringWithOwnership _COL_SDBRWER_IBM_USE          ;
    static const StringWithOwnership _COL_FIELD1                   ;
    static const StringWithOwnership _COL_FIELD2                   ;
    static const StringWithOwnership _COL_FIELD3                   ;
    static const StringWithOwnership _COL_FIELD4                   ;
    static const StringWithOwnership _COL_FIELD5                   ;
    static const StringWithOwnership _COL_FIELD6                   ;

   public: // Get functions
    const String& getShopperRefNum (bool Real=true);
    const String& getGender        (bool Real=true);
             bool isGenderMale           (bool Real=true) { return getGender(Real) == _VAL_GENDER_MALE           ; }
             bool isGenderFemale         (bool Real=true) { return getGender(Real) == _VAL_GENDER_FEMALE         ; }
             bool isGenderUnknown        (bool Real=true) { return getGender(Real) == _VAL_GENDER_UNKNOWN        ; }
    const String& getAge           (bool Real=true);
             bool isAgeUnknown        (bool Real=true) { return getAge(Real) == _VAL_AGE_UNKNOWN           ; }
             bool isAgeOption1        (bool Real=true) { return getAge(Real) == _VAL_AGE_OPTION1           ; }
             bool isAgeOption2        (bool Real=true) { return getAge(Real) == _VAL_AGE_OPTION2           ; }
             bool isAgeOption3        (bool Real=true) { return getAge(Real) == _VAL_AGE_OPTION3           ; }
             bool isAgeOption4        (bool Real=true) { return getAge(Real) == _VAL_AGE_OPTION4           ; }
             bool isAgeOption5        (bool Real=true) { return getAge(Real) == _VAL_AGE_OPTION5           ; }
             bool isAgeOption6        (bool Real=true) { return getAge(Real) == _VAL_AGE_OPTION6           ; }
             bool isAgeOption7        (bool Real=true) { return getAge(Real) == _VAL_AGE_OPTION7           ; }
    const String& getIncome        (bool Real=true);
             bool isIncomeUnknown        (bool Real=true) { return getIncome(Real) == _VAL_INCOME_UNKNOWN        ; }
             bool isIncomeOption1        (bool Real=true) { return getIncome(Real) == _VAL_INCOME_OPTION1        ; }
             bool isIncomeOption2        (bool Real=true) { return getIncome(Real) == _VAL_INCOME_OPTION2        ; }
             bool isIncomeOption3        (bool Real=true) { return getIncome(Real) == _VAL_INCOME_OPTION3        ; }
             bool isIncomeOption4        (bool Real=true) { return getIncome(Real) == _VAL_INCOME_OPTION4        ; }
    const String& getMaritalStatus (bool Real=true);
             bool isMaritalStatusUnknown        (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_UNKNOWN; }
             bool isMaritalStatusSingle         (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_SINGLE ; }
             bool isMaritalStatusMarries        (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_MARRIED; }
             bool isMaritalStatusCommonLaw      (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_COMMON_LAW; }
             bool isMaritalStatusSeparated      (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_SEPARATED; }
             bool isMaritalStatusDivorced       (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_DIVORCED; }
             bool isMaritalStatusWidowed        (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_WIDOWED; }
             bool isMaritalStatusOther          (bool Real=true) { return getMaritalStatus(Real) == _VAL_MARITAL_STATUS_OTHER  ; }
    const String& getChildren      (bool Real=true);
    const String& getHousehold     (bool Real=true);
    const String& getCompany       (bool Real=true);
    const String& getInterests     (bool Real=true);
    const String& getAlreadyOrdered(bool Real=true);
             bool isAlreadyOrderedYes            (bool Real=true) { return getAlreadyOrdered(Real) == _VAL_ALREADY_ORDERED_YES   ; }
             bool isAlreadyOrderedNo             (bool Real=true) { return getAlreadyOrdered(Real) == _VAL_ALREADY_ORDERED_NO    ; }
    const String& getIbmUse        (bool Real=true);
    const String& getField1        (bool Real=true);
    const String& getField2        (bool Real=true);
    const String& getField3        (bool Real=true);
    const String& getField4        (bool Real=true);
    const String& getField5        (bool Real=true);
    const String& getField6        (bool Real=true);

   public: // Set functions
    void setShopperRefNum (const String& ShopperRefNum ) { SQL_Schema::setValue(_COL_SHOPPER_REF_NUM          ,ShopperRefNum ); }
    void setGender        (const String& Gender        ) { SQL_Schema::setValue(_COL_GENDER                   ,Gender        ); }
    void setAge           (const String& Age           ) { SQL_Schema::setValue(_COL_AGE                      ,Age           ); }
    void setIncome        (const String& Income        ) { SQL_Schema::setValue(_COL_INCOME                   ,Income        ); }
    void setMaritalStatus (const String& MaritalStatus ) { SQL_Schema::setValue(_COL_MARITAL_STATUS           ,MaritalStatus ); }
    void setChildren      (const String& Children      ) { SQL_Schema::setValue(_COL_CHILDREN                 ,Children      ); }
    void setHousehold     (const String& Household     ) { SQL_Schema::setValue(_COL_HOUSEHOLD                ,Household     ); }
    void setCompany       (const String& Company       ) { SQL_Schema::setValue(_COL_COMPANY                  ,Company       ); }
    void setInterests     (const String& Interests     ) { SQL_Schema::setValue(_COL_INTERESTS                ,Interests     ); }
    void setAlreadyOrdered(const String& AlreadyOrdered) { SQL_Schema::setValue(_COL_ALREADY_ORDERED          ,AlreadyOrdered); }
    void setIbmUse        (const String& IbmUse        ) { SQL_Schema::setValue(_COL_SDBRWER_IBM_USE          ,IbmUse        ); }
    void setField1        (const String& Field1        ) { SQL_Schema::setValue(_COL_FIELD1                   ,Field1        ); }
    void setField2        (const String& Field2        ) { SQL_Schema::setValue(_COL_FIELD2                   ,Field2        ); }
    void setField3        (const String& Field3        ) { SQL_Schema::setValue(_COL_FIELD3                   ,Field3        ); }
    void setField4        (const String& Field4        ) { SQL_Schema::setValue(_COL_FIELD4                   ,Field4        ); }
    void setField5        (const String& Field5        ) { SQL_Schema::setValue(_COL_FIELD5                   ,Field5        ); }
    void setField6        (const String& Field6        ) { SQL_Schema::setValue(_COL_FIELD6                   ,Field6        ); }
 };



class __DLL_NCS_OBJ__ UserDemographicsHome : public SQL_SchemaMap<UserDemographics>
 {
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   static const FuncName  _STR_Create;
   static const FuncName  _STR_Lookup;

   public:
    UserDemographicsHome(DataBase& DB)  : SQL_SchemaMap<UserDemographics>(DB) { }


   public:
    UserDemographics* Create(const String& ShopperRefNum, const NVPHash& NameValuePairs);
    UserDemographics* Lookup(const String& ShopperRefNum, const NVPHash& NameValuePairs);
 };



class __DLL_NCS_OBJ__ UserDemographicsNVP : public NC_Void
 {
   #if !defined(AS400)
   static const ClassName _STR_ThisClass;  // Strings used for tracing and debugging
   #endif

   public:
       static const StringWithOwnership _NVP_GENDER                ;
       static const StringWithOwnership _NVP_AGE                   ;
       static const StringWithOwnership _NVP_INCOME                ;
       static const StringWithOwnership _NVP_MARITAL_STATUS        ;
       static const StringWithOwnership _NVP_CHILDREN              ;
       static const StringWithOwnership _NVP_HOUSEHOLD             ;
       static const StringWithOwnership _NVP_COMPANY               ;
       static const StringWithOwnership _NVP_INTERESTS             ;
       static const StringWithOwnership _NVP_ALREADY_ORDERED       ;
       static const StringWithOwnership _NVP_SDBRWER_IBM_USE       ;
       static const StringWithOwnership _NVP_FIELD1                ;
       static const StringWithOwnership _NVP_FIELD2                ;
       static const StringWithOwnership _NVP_FIELD3                ;
       static const StringWithOwnership _NVP_FIELD4                ;
       static const StringWithOwnership _NVP_FIELD5                ;
       static const StringWithOwnership _NVP_FIELD6                ;

   public:
    static bool CreateSchemaNVP(const HttpRequest& Req, NC_Environment& Env,
                                const String& ErrorTask, const String& MerchantRefNum,
                                NVPHash& NameValuePairs
                               );
    static void SetThroughNVP  (const HttpRequest& Req, UserDemographics* R);

 };



#endif

